SystemOrganization addCategory: #'WebStore-Core'!
SystemOrganization addCategory: #'WebStore-Announcements'!
SystemOrganization addCategory: #'WebStore-Components'!
SystemOrganization addCategory: #'WebStore-Admin'!
SystemOrganization addCategory: #'WebStore-Util'!
SystemOrganization addCategory: #'WebStore-Checkout'!
SystemOrganization addCategory: #'WebStore-Commands'!
SystemOrganization addCategory: #'WebStore-MagmaPools'!

Notification subclass: #WSCurrentTransactionProvider
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-MagmaPools'!

!WSCurrentTransactionProvider class methodsFor: 'as yet unclassified' stamp: 'srh 4/20/2009 21:03'!
use: sessionFactoryBlock during: aBlock
	" The sessionFactoryBlock should be a block which will return a new session instance" 
	^ aBlock on: self do: [ :notification | notification resume: sessionFactoryBlock value ]! !

!WSCurrentTransactionProvider class methodsFor: 'as yet unclassified' stamp: 'srh 4/19/2009 23:11'!
value
	^self raiseSignal! !

WAKom subclass: #WSKom
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Util'!

!WSKom commentStamp: 'srh 2/22/2009 19:55' prior: 0!
A WSKom is a specialized subclass of WAKom that merges GET fields and POST fields on POST.
!

!WSKom class methodsFor: 'as yet unclassified' stamp: 'srh 4/13/2009 15:27'!
initialize
	self register! !

!WSKom class methodsFor: 'as yet unclassified' stamp: 'srh 4/13/2009 15:34'!
startUp
	self name = #WSKom ifTrue: [
		SmalltalkImage current extractParameters 
			at: 'PORT' ifPresent: [ :value |
				value isEmptyOrNil
					ifFalse: [ port := value asInteger ] ] ].
	port ifNotNil: [ self startOn: port ]! !

!WSKom methodsFor: 'as yet unclassified' stamp: 'srh 2/22/2009 19:53'!
fieldsOf: aKomRequest
	^aKomRequest method = 'POST'
		ifTrue: [ Dictionary new 
			addAll: aKomRequest getFields;
			addAll: aKomRequest postFields;
			yourself]
		ifFalse: [ aKomRequest getFields ]! !

!WARenderCanvas methodsFor: '*webstore-components' stamp: 'srh 3/10/2009 21:58'!
wsImage
	^self brush: WSImageBrush new! !

!WARenderCanvas methodsFor: '*webstore-components' stamp: 'srh 3/10/2009 22:01'!
wsImage: anImage
	^(self brush: WSImageBrush new) 
		image:anImage;
		yourself! !

Announcement subclass: #WSAddToCart
	instanceVariableNames: 'product'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Announcements'!

!WSAddToCart class methodsFor: 'as yet unclassified' stamp: 'srh 3/10/2009 21:16'!
product: aProduct
	^self basicNew
		initializeWithProduct: aProduct;
		yourself! !

!WSAddToCart methodsFor: 'initialization' stamp: 'srh 3/10/2009 21:24'!
initializeWithProduct: aProduct
	product := aProduct.
	self initialize.! !

!WSAddToCart methodsFor: 'accessing' stamp: 'srh 3/10/2009 21:24'!
product
	^product! !

Announcement subclass: #WSLightbox
	instanceVariableNames: 'component'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Util'!

!WSLightbox class methodsFor: 'as yet unclassified' stamp: 'srh 3/10/2009 20:59'!
component: aComponent
	^self basicNew
		initializeWithComponent: aComponent;
		yourself! !

!WSLightbox methodsFor: 'accessing' stamp: 'srh 3/10/2009 20:37'!
component
	^component! !

!WSLightbox methodsFor: 'initialization' stamp: 'srh 3/10/2009 20:37'!
initializeWithComponent: aComponent 
	component := aComponent.
	self initialize! !

WAFileLibrary subclass: #WSAdminLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Admin'!

!WSAdminLibrary methodsFor: 'as yet unclassified' stamp: 'srh 5/18/2009 17:50'!
selectorsToInclude
	^#(styleCss)! !

!WSAdminLibrary methodsFor: 'as yet unclassified' stamp: 'srh 7/19/2009 15:37'!
styleCss
	^'#home fieldSet {
float: left;
width: 45%;
}
#home h2  a {
text-decoration: none;
display: block;
color: black;
font-family: sans;
text-align: center;
height: 100%;
}
#home h2 {
border: outset 1px red;
width: 10em;
float: left;
margin-left: 1em;
font-size: 1.2em;
background-color: #ffcccc;
}

#home h2:hover {
border-style: inset;
}


.actions {
margin-bottom: 0.5em;
border: solid black 1px;
background-color: #cccccc;
}

.actions a {
color: blue;
text-decoration: none;
padding-left: 0.3em;
padding-right: 0.3em;
}
.actions a:hover {
background-color: #dddddd;
color: red;
}

table {
border-collapse: collapse
}

th {
background-color: #cccccc;
border: 1px solid #444444;
}

td {
border: 1px solid #444444;
vertical-align: top;
padding-top: 2px;
padding-bottom: 2px;
padding-left: 5px;
padding-right: 5px;
}

td.hl {
background-color: #eeeeee;
}'! !

WAFileLibrary subclass: #WSImageLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Util'!

!WSImageLibrary commentStamp: '<historical>' prior: 0!
This class adds the ability to serve content from files external to the image.

The files go in to a subdirectory from the running directory called 'files'
The URL to access the files is: http://localhost:7777/seaside/files/external/myfile.png

Seaside protects against malicious users attempting to use '..' to access above the 'files' directory.!

!WSImageLibrary class methodsFor: 'testing' stamp: 'srh 12/31/2008 08:05'!
handlesFolder: aSymbol 
	^ aSymbol = #external! !

!WSImageLibrary methodsFor: 'accessing' stamp: 'srh 12/31/2008 08:31'!
documentAt: aFilename ifAbsent: aBlock 
	| fn files mimeType fileStream |
	files := FileDirectory default directoryNamed: 'files'.
	files exists
		ifFalse: [^ aBlock value].
	fn := files fullNameFor: aFilename.
	^ (files fileOrDirectoryExists: fn)
		ifTrue: [mimeType := self mimetypeForFile: aFilename.
			fileStream := (files readOnlyFileNamed: fn) binary.
			(WAStreamResponse on: fileStream)
				contentType: (mimeType
						ifNil: ['application/octet-stream']);
				 headerAt: 'Expires' put: 'Thu, 01 Jan 2095 12:00:00 GMT';
				 yourself]
		ifFalse: [aBlock value]! !

!WSImageLibrary methodsFor: 'accessing' stamp: 'srh 4/14/2009 11:53'!
urlOf: aSymbol using: aHandler 
	^ aHandler baseUrl addToPath: 'external';
		
		addToPath: (self asFilename: aSymbol);
		 yourself! !

WAComponent subclass: #WSCancelableInputDialog
	instanceVariableNames: 'message value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Util'!

!WSCancelableInputDialog class methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 17:05'!
message: aMessage
	^self basicNew
		initializeWithMessage: aMessage;
		yourself! !

!WSCancelableInputDialog methodsFor: 'as yet unclassified' stamp: 'srh 3/9/2009 11:13'!
initializeWithMessage: aMessage
	self initialize.
	message := aMessage.! !

!WSCancelableInputDialog methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 21:07'!
renderContentOn: html
	html heading level: 3; with: message.
	html form
		defaultAction: [self submit];
		with: [
			html textInput on: #value of: self.
			html space.
			html submitButton value: 'Ok';
				callback: [ self submit].
			html space.
			html cancelButton value: 'Cancel'; callback: [self answer: nil] ]! !

!WSCancelableInputDialog methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 21:07'!
submit
	(value notNil and: [value notEmpty ]) ifTrue: [
		self answer: value] 
! !

!WSCancelableInputDialog methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 17:08'!
value
	^value! !

!WSCancelableInputDialog methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 17:07'!
value: aValue
	value := aValue.! !

WAComponent subclass: #WSCheckoutWizard
	instanceVariableNames: 'page order pages'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Checkout'!

!WSCheckoutWizard methodsFor: 'actions' stamp: 'srh 6/28/2009 21:37'!
back
	^ page := pages before: page! !

!WSCheckoutWizard methodsFor: 'actions' stamp: 'srh 6/28/2009 21:37'!
cancel
	^ self answer: nil! !

!WSCheckoutWizard methodsFor: 'accessing' stamp: 'cmd 3/21/2009 16:46'!
children
	^Array with: page! !

!WSCheckoutWizard methodsFor: 'actions' stamp: 'srh 1/3/2009 10:34'!
goToFirstPage
	page := pages first! !

!WSCheckoutWizard methodsFor: 'initialization' stamp: 'srh 2/24/2009 21:30'!
initialize
	super initialize.
	page := WSCustomerPage new.
	pages := OrderedCollection new
		add: WSCartViewPage new;
		add: page;
		add: WSShippingAddressPage new;
		add: WSConfirmOrderPage new;
		yourself.
	order := WSOrder new.
	order items: self session cart.
	pages do: [ :p | p model: order ].
	page onEnter.! !

!WSCheckoutWizard methodsFor: 'actions' stamp: 'srh 6/28/2009 21:36'!
next
	^ (page save and: [ page valid ]) ifTrue: 
		[ page := pages after: page.
		page onEnter ]! !

!WSCheckoutWizard methodsFor: 'actions' stamp: 'srh 6/28/2009 21:36'!
pay
	^ (page save and: [ page valid ]) ifTrue: [ self answer: order ]! !

!WSCheckoutWizard methodsFor: 'rendering' stamp: 'srh 6/28/2009 21:53'!
renderBackButtonOn: html 
	page = pages first ifFalse: 
		[ html cancelButton
			callback: [ self back ];
			value: 'Previous' ]! !

!WSCheckoutWizard methodsFor: 'rendering' stamp: 'srh 6/28/2009 21:54'!
renderButtonsOn: html 
	html div
		class: 'nav-buttons';
		with: 
			[ self renderBackButtonOn: html.
			html space.
			self renderNextButtonOn: html.
			html space.
			self renderCancelButtonOn: html ]! !

!WSCheckoutWizard methodsFor: 'rendering' stamp: 'srh 6/28/2009 21:54'!
renderCancelButtonOn: html 
	^ html cancelButton
		callback: [ self cancel ];
		value: 'Cancel'! !

!WSCheckoutWizard methodsFor: 'rendering' stamp: 'srh 6/28/2009 21:55'!
renderContentOn: html
	self renderNavOn: html.
	html form
		defaultAction: [ page = pages last ifTrue: [ self pay] ifFalse: [ self next ]];
		with: [
		html render: page.
		self renderButtonsOn: html
	]! !

!WSCheckoutWizard methodsFor: 'rendering' stamp: 'srh 6/28/2009 22:31'!
renderNavOn: html 
	html unorderedList
		class: 'wizard-tabs';
		with: 
			[ pages do: 
				[ :p | | enabled |
				enabled := p enabled and: [ pages first valid ].
				html listItem
					class: (enabled ifFalse: [ 'disabled' ]);
					with: 
						[ (p = page or: [ enabled not ]) 
							ifTrue: [ html text: p title ]
							ifFalse: 
								[ html anchor
									callback: [ page := p ];
									with: p title ] ] ] ]! !

!WSCheckoutWizard methodsFor: 'rendering' stamp: 'srh 6/28/2009 22:29'!
renderNextButtonOn: html 
	page = pages last 
		ifFalse: 
			[ (page = pages first and: [ page valid not ])  
				ifFalse: [html submitButton
					callback: [ self next ];
					value: 'Next' ]]
		ifTrue: 
			[ html submitButton
				callback: [ self pay ];
				value: 'Pay with Paypal' ]! !

!WSCheckoutWizard methodsFor: 'accessing' stamp: 'srh 4/22/2009 00:17'!
title
	^page title! !

WAComponent subclass: #WSComponent
	instanceVariableNames: 'baseUrl'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Components'!

WSComponent subclass: #WSCartView
	instanceVariableNames: 'cart'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Components'!

!WSCartView class methodsFor: 'as yet unclassified' stamp: 'srh 3/14/2009 11:26'!
cart: aCart
	^self basicNew
		initializeWithCart: aCart;
		yourself! !

!WSCartView class methodsFor: 'as yet unclassified' stamp: 'srh 3/9/2009 15:53'!
new
	self shouldNotImplement! !

!WSCartView methodsFor: 'as yet unclassified' stamp: 'srh 1/4/2009 13:57'!
cart
	^cart! !

!WSCartView methodsFor: 'as yet unclassified' stamp: 'srh 3/21/2009 10:09'!
editItem: aProductEntry
	self lightbox: (WSEditOrderItem product: aProductEntry )! !

!WSCartView methodsFor: 'as yet unclassified' stamp: 'srh 3/14/2009 11:26'!
initializeWithCart: aCart
	cart := aCart.
	self initialize.
! !

!WSCartView methodsFor: 'as yet unclassified' stamp: 'srh 6/28/2009 22:21'!
renderContentOn: html 
	html div
		class: 'cart-view';
		with: 
			[ cart isEmpty 
				ifTrue: [ self renderEmptyOrderOn: html ]
				ifFalse: [ self renderOrderContentsOn: html ] ]! !

!WSCartView methodsFor: 'as yet unclassified' stamp: 'srh 6/28/2009 22:14'!
renderEmptyOrderOn: html
	html paragraph: 'Your order contains no items.'! !

!WSCartView methodsFor: 'as yet unclassified' stamp: 'srh 8/4/2009 16:00'!
renderOrderContentsOn: html 
	^ html table: 
		[ html tableRow: 
			[ html tableHeading
				colSpan: 2;
				with: 'Item'.
			html tableHeading: 'Price'.
			html tableHeading ].
		html tableBody
			id: 'cart-items';
			with: 
				[ self cart items do: 
					[ :p | 
					html tableRow: 
						[ html tableData: [ p preview ifNotNil: [ html wsImage: p preview thumbnail ] ].
						html tableData: 
							[ html anchor
								callback: [ self editItem: p ];
								with: p name ].
						html tableData: '$' , p priceInDollars.
						html tableData: 
							[ html anchor
								callback: [ self cart remove: p ];
								with: 'Remove' ] ] ] ].
		html tableRow: 
			[ html tableData.
			html tableData: 'Total: '.
			html tableHeading
				id: 'cart-total';
				with: '$' , self cart totalInDollars.
			html tableData ] ]! !

WSComponent subclass: #WSCartViewDialog
	instanceVariableNames: 'cartView'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Components'!

!WSCartViewDialog class methodsFor: 'as yet unclassified' stamp: 'srh 3/9/2009 15:44'!
cart: aCart
	^self basicNew
		initializeWithCart: aCart;
		yourself! !

!WSCartViewDialog class methodsFor: 'as yet unclassified' stamp: 'srh 3/9/2009 15:44'!
new
	self shouldNotImplement! !

!WSCartViewDialog methodsFor: 'accessing' stamp: 'srh 1/1/2009 10:59'!
children
	^Array with: cartView.! !

!WSCartViewDialog methodsFor: 'accessing' stamp: 'srh 3/21/2009 12:50'!
initializeWithCart: aCart
	self initialize.
	cartView := WSCartView cart: aCart! !

!WSCartViewDialog methodsFor: 'rendering' stamp: 'srh 6/28/2009 22:26'!
renderContentOn: html
		html render: cartView.
		html div class: 'nav-buttons'; with: [
		html anchor callback: [ self answer]; with: 'Back'.
		cartView cart isEmpty ifFalse: [ html text: ' '.
			html anchor callback: [ self answer: (self call: WSCheckoutProcess new) ]; with: 'Checkout']
	]! !

!WSCartViewDialog methodsFor: 'rendering' stamp: 'srh 4/22/2009 00:16'!
title
	^'Current Order'! !

WSComponent subclass: #WSCartWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Components'!

!WSCartWidget methodsFor: 'accessing' stamp: 'srh 12/31/2008 14:34'!
cart
	^self session cart.! !

!WSCartWidget methodsFor: 'rendering' stamp: 'srh 8/4/2009 16:00'!
renderContentOn: html 
	self cart isEmpty ifFalse: 
		[ html div
			class: 'cart-widget';
			with: 
				[ html heading
					level: 3;
					with: 'Your Order'.
				html paragraph: 'Items: ' , self cart count printString , ' Total: $' , self cart totalInDollars.
				html paragraph: 
					[ html anchor
						callback: [ self lightbox: (WSCartViewDialog cart: self cart) ];
						with: 'Review' ] ] ]! !

!WSComponent methodsFor: 'as yet unclassified' stamp: 'srh 3/10/2009 21:27'!
announce: anAnnouncement
	^self session announce: anAnnouncement! !

!WSComponent methodsFor: 'as yet unclassified' stamp: 'srh 3/30/2009 17:48'!
baseUrl
    ^ (baseUrl ifNil: [ baseUrl := self session baseUrl ]) copy! !

!WSComponent methodsFor: 'as yet unclassified' stamp: 'srh 3/10/2009 21:27'!
lightbox: aComponent
	self announce: (WSLightbox component: aComponent)! !

!WSComponent methodsFor: 'as yet unclassified' stamp: 'srh 4/22/2009 00:12'!
title
	^''! !

!WSComponent methodsFor: 'as yet unclassified' stamp: 'srh 4/11/2009 12:40'!
urlForProduct: aProduct
	^self session urlForProduct: aProduct! !

WSComponent subclass: #WSEditOrderItem
	instanceVariableNames: 'product form'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Components'!

WSEditOrderItem subclass: #WSAddOrderItem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Components'!

!WSAddOrderItem methodsFor: 'as yet unclassified' stamp: 'srh 3/13/2009 22:21'!
addProduct: aProduct
	self announce: (WSAddToCart product: aProduct)! !

!WSAddOrderItem methodsFor: 'as yet unclassified' stamp: 'srh 3/13/2009 22:20'!
beforeAnswer
	self addProduct: product! !

!WSAddOrderItem methodsFor: 'as yet unclassified' stamp: 'srh 3/13/2009 20:41'!
buttonText
	^'Add to Order'! !

!WSAddOrderItem methodsFor: 'as yet unclassified' stamp: 'srh 3/21/2009 14:11'!
initializeWithProduct: aProduct
	super initializeWithProduct: aProduct orderCopy! !

!WSAddOrderItem methodsFor: 'as yet unclassified' stamp: 'srh 3/13/2009 20:40'!
title
	^'Add Item'! !

!WSEditOrderItem class methodsFor: 'as yet unclassified' stamp: 'srh 3/13/2009 20:24'!
product: aProduct
	^self basicNew
		initializeWithProduct: aProduct;
		yourself.! !

!WSEditOrderItem methodsFor: 'as yet unclassified' stamp: 'srh 3/13/2009 22:20'!
beforeAnswer
	"nothing!!"
	! !

!WSEditOrderItem methodsFor: 'as yet unclassified' stamp: 'srh 3/13/2009 20:38'!
buttonText
	^'Save'! !

!WSEditOrderItem methodsFor: 'as yet unclassified' stamp: 'srh 3/12/2009 22:07'!
cancel
	^self answer: nil! !

!WSEditOrderItem methodsFor: 'as yet unclassified' stamp: 'srh 3/11/2009 14:46'!
children
	^Array with: form.! !

!WSEditOrderItem methodsFor: 'as yet unclassified' stamp: 'srh 3/13/2009 20:46'!
initializeWithProduct: aProduct
	self initialize.
	form := WSForm new.
	product := aProduct.
	self setUpFields! !

!WSEditOrderItem methodsFor: 'as yet unclassified' stamp: 'srh 4/22/2009 00:16'!
renderContentOn: html
		html form id: 'add-item'; with: [
		self renderItemOn: html.
		html div class: 'nav-buttons'; with: [
		html submitButton callback: [ self saveAndAnswer ]; with:self buttonText.
		html text: ' '.
		html cancelButton callback: [ self cancel]; with: 'Cancel']]! !

!WSEditOrderItem methodsFor: 'as yet unclassified' stamp: 'srh 8/4/2009 15:37'!
renderItemOn: html 
	html div
		class: 'item';
		with: 
			[ product preview ifNotNil: [ html wsImage: product preview preview ].
			html paragraph: product name.
			html paragraph: product priceInDollars ].
	product options ifNotEmpty: 
		[ html paragraph: 'This item requires additional information before it can be added to your order'.
		html render: form ]! !

!WSEditOrderItem methodsFor: 'as yet unclassified' stamp: 'srh 3/21/2009 21:56'!
saveAndAnswer
	form valid ifFalse: [ ^ self ].
	form save.
	self beforeAnswer.
	self answer: product! !

!WSEditOrderItem methodsFor: 'as yet unclassified' stamp: 'srh 3/12/2009 22:13'!
setUpFields
	product options do: 
		[ :o | 
		| field |
		field := o editField
			label: o name;
			yourself.
		o required ifTrue: [ field beRequired ].
		form add: field ]! !

!WSEditOrderItem methodsFor: 'as yet unclassified' stamp: 'srh 3/13/2009 20:38'!
title
	^'Edit Item'! !

WSComponent subclass: #WSOptionComponent
	instanceVariableNames: 'option'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Components'!

!WSOptionComponent class methodsFor: 'as yet unclassified' stamp: 'srh 5/4/2009 17:36'!
option: anOption
	^self basicNew
		initializeWithOption: anOption;
		yourself.! !

!WSOptionComponent methodsFor: 'as yet unclassified' stamp: 'srh 5/4/2009 17:37'!
initializeWithOption: anOption
	self initialize.
	option := anOption! !

!WSOptionComponent methodsFor: 'as yet unclassified' stamp: 'srh 5/4/2009 17:38'!
renderContentOn: html
	html div: [
		html strong: option name.
		html paragraph: option value]! !

WSComponent subclass: #WSProductDetails
	instanceVariableNames: 'product imageViewer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Components'!

!WSProductDetails class methodsFor: 'as yet unclassified' stamp: 'cmd 3/21/2009 17:18'!
for: aProduct
	^self basicNew
		initializeWithProduct: aProduct;
		yourself.! !

!WSProductDetails methodsFor: 'as yet unclassified' stamp: 'srh 12/31/2008 08:53'!
children
	^Array with: imageViewer.! !

!WSProductDetails methodsFor: 'as yet unclassified' stamp: 'cmd 3/21/2009 17:17'!
initializeWithProduct: aProduct
	self initialize.
	product := aProduct.
	imageViewer := WSProductImageView for: product.! !

!WSProductDetails methodsFor: 'as yet unclassified' stamp: 'srh 8/4/2009 15:37'!
renderContentOn: html 
	html div
		class: 'product-details';
		with: 
			[ html render: imageViewer.
			html paragraph: 
				[ html text: '$' , product priceInDollars.
				html space.
				html anchor
					callback: [ self lightbox: (WSAddOrderItem product: product) ];
					with: 'Add to Order' ] ].
	html paragraph with: product description.
	html paragraph: 
		[ html anchor
			url: self storeUrl;
			with: 'Return to list' ]! !

!WSProductDetails methodsFor: 'as yet unclassified' stamp: 'srh 7/27/2009 15:15'!
storeUrl
	^(self session baseUrl addToPath: #store)! !

!WSProductDetails methodsFor: 'as yet unclassified' stamp: 'srh 4/21/2009 21:10'!
title
	^product name! !

!WSProductDetails methodsFor: 'as yet unclassified' stamp: 'srh 4/11/2009 13:31'!
updateUrl: aUrl
	aUrl addParameter: #product value: product id.
	super updateUrl: aUrl.
! !

WSComponent subclass: #WSProductImageView
	instanceVariableNames: 'current product'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Components'!

!WSProductImageView class methodsFor: 'as yet unclassified' stamp: 'cmd 3/21/2009 17:21'!
for: aProduct
	^self basicNew
		initializeWithProduct: aProduct;
		yourself.! !

!WSProductImageView methodsFor: 'as yet unclassified' stamp: 'cmd 3/21/2009 17:21'!
initializeWithProduct: aProduct.
	self initialize.
	product := aProduct.
	current := product preview.! !

!WSProductImageView methodsFor: 'as yet unclassified' stamp: 'srh 4/14/2009 12:14'!
renderContentOn: html 
	product images ifEmpty: [ ^ self ].
	html div
		class: 'image-viewer';
		with: 
			[ html anchor
				url: WSImageLibrary / current fullsize;
				with: [ html wsImage: current medium ].
			html unorderedList: 
				[ (product images do: 
					[ :i | 
					html listItem: 
						[ self renderThumbnailFor: i on: html ] ])]]! !

!WSProductImageView methodsFor: 'as yet unclassified' stamp: 'cmd 3/21/2009 17:45'!
renderThumbnailFor: image on: html
	current = image 
		ifTrue: [ html wsImage: image thumbnail ]
		ifFalse: [
			html anchor
			callback: [ current := image ];
			with: [ html wsImage: image thumbnail]]! !

WSComponent subclass: #WSProductList
	instanceVariableNames: 'products'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Components'!

!WSProductList class methodsFor: 'as yet unclassified' stamp: 'srh 1/2/2009 17:24'!
products: aCollection
	^self basicNew
		products: aCollection;
		initialize.! !

!WSProductList methodsFor: 'as yet unclassified' stamp: 'srh 4/10/2009 14:33'!
children
	^products! !

!WSProductList methodsFor: 'as yet unclassified' stamp: 'srh 4/10/2009 14:33'!
products: aCollection
	products := (aCollection select: [ :p | p enabled ]) 
		collect: [ :p | WSProductPreview product: p ]
	! !

!WSProductList methodsFor: 'as yet unclassified' stamp: 'srh 4/10/2009 14:34'!
renderContentOn: html
	products do: [ :p | html render: p]! !

WSComponent subclass: #WSProductPreview
	instanceVariableNames: 'product'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Components'!

!WSProductPreview class methodsFor: 'as yet unclassified' stamp: 'srh 4/10/2009 14:36'!
product: aProduct
	^self basicNew 
		initializeWithProduct: aProduct;
		yourself.! !

!WSProductPreview methodsFor: 'as yet unclassified' stamp: 'srh 4/10/2009 14:35'!
initializeWithProduct: aProduct
	product := aProduct.
	self initialize! !

!WSProductPreview methodsFor: 'as yet unclassified' stamp: 'srh 8/4/2009 15:37'!
renderContentOn: html 
	html div
		class: 'product-preview';
		with: 
			[ html anchor
				class: 'image';
				url: (self urlForProduct: product);
				with: [ product preview ifNotNil: [ html wsImage: product preview preview ] ].
			html heading
				level: 3;
				with: product name	"[
				html anchor url: (self urlForProduct: product); with: product name]." ].
	html paragraph: 
		[ html text: '$' , product priceInDollars.
		html space.
		html anchor
			callback: [ self lightbox: (WSAddOrderItem product: product) ];
			with: 'Add to Order' ].
	html paragraph: product description! !

WAComponent subclass: #WSFormElement
	instanceVariableNames: 'rules'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Util'!

WSFormElement subclass: #WSDisplayElement
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Util'!

!WSDisplayElement class methodsFor: 'as yet unclassified' stamp: 'srh 3/9/2009 13:01'!
value: anObject
	^self basicNew
		initializeWithValue: anObject;
		yourself.! !

!WSDisplayElement methodsFor: 'as yet unclassified' stamp: 'srh 3/9/2009 13:02'!
initializeWithValue: anObject
	value := anObject.
	self initialize.! !

!WSDisplayElement methodsFor: 'as yet unclassified' stamp: 'srh 3/9/2009 13:02'!
renderContentOn: html
	html text: value displayString.! !

!WSDisplayElement methodsFor: 'as yet unclassified' stamp: 'srh 3/9/2009 13:03'!
value
	^value! !

WSFormElement subclass: #WSField
	instanceVariableNames: 'value selector receiver tag label description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Util'!

WSField subclass: #WSCountryField
	instanceVariableNames: 'default countryList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Util'!

!WSCountryField methodsFor: 'as yet unclassified' stamp: 'srh 6/27/2009 11:10'!
default: aCountryCode
	default := WSCountry byCode: aCountryCode
	! !

!WSCountryField methodsFor: 'as yet unclassified' stamp: 'srh 6/27/2009 11:17'!
initialize
	super initialize.
	countryList := WSCountry countryList sort: [ :a :b | a name < b name ]..
	self default: 'AU'.! !

!WSCountryField methodsFor: 'as yet unclassified' stamp: 'srh 6/27/2009 11:22'!
readInitialValue
	value := (receiver perform: selector) ifNil: [default]
! !

!WSCountryField methodsFor: 'as yet unclassified' stamp: 'srh 6/27/2009 11:20'!
renderContentOn: html
	html div class: (self valid ifFalse: ['error']); with: [
		| id |
		id := html nextId.
		html label for: id; with: self label, ':'.
		html select list: countryList;
		selected: value;
		labels: [ :a | a name];
		callback: [ :v | value := v].
		description ifNotNil: [html paragraph class: 'desc'; with: description]]! !

!WSField class methodsFor: 'as yet unclassified' stamp: 'srh 3/8/2009 16:21'!
checkbox
	^self basicNew
		tagType:  #checkbox;
		initialize;
		yourself.! !

!WSField class methodsFor: 'as yet unclassified' stamp: 'srh 12/30/2008 21:50'!
image
	^WSImageField new.! !

!WSField class methodsFor: 'as yet unclassified' stamp: 'srh 12/31/2008 10:28'!
integer
	^WSIntegerField new.! !

!WSField class methodsFor: 'as yet unclassified' stamp: 'srh 12/30/2008 18:57'!
largeText
	^self basicNew
		tagType:  #textArea;
		initialize;
		yourself.! !

!WSField class methodsFor: 'as yet unclassified' stamp: 'srh 12/30/2008 18:15'!
money
	^WSMoneyField new.! !

!WSField class methodsFor: 'as yet unclassified' stamp: 'srh 3/11/2009 14:43'!
numeric
	^WSNumericField new.! !

!WSField class methodsFor: 'as yet unclassified' stamp: 'srh 12/30/2008 18:13'!
text
	^self basicNew
		tagType:  #textInput;
		initialize;
		yourself.! !

!WSField methodsFor: 'accessing' stamp: 'srh 1/26/2009 14:24'!
beRequired
	"Nil is allowed, because the only time it'll be nil is when the form is first rendered"
	self addRule: [ :v| v isNil or: [v notEmpty]] withDescription: self label, ' is a required field'.! !

!WSField methodsFor: 'accessing' stamp: 'srh 4/21/2009 21:33'!
description: aDescription
	description := aDescription.! !

!WSField methodsFor: 'accessing' stamp: 'srh 1/26/2009 14:24'!
label
	^label ifNil:[label := selector asCapitalizedPhrase]! !

!WSField methodsFor: 'accessing' stamp: 'srh 12/30/2008 17:05'!
label: aString
	label := aString! !

!WSField methodsFor: 'accessing' stamp: 'srh 3/21/2009 21:55'!
messages
	^ (rules reject: [ :r | r testRule: value ]) collect: [ :r | r message ]! !

!WSField methodsFor: 'callbacks' stamp: 'srh 3/8/2009 21:43'!
on: aSelector of: aReceiver 
	selector := aSelector.
	receiver := aReceiver.
	self readInitialValue! !

!WSField methodsFor: 'initialization' stamp: 'srh 3/8/2009 21:43'!
readInitialValue
	value := receiver perform: selector! !

!WSField methodsFor: 'rendering' stamp: 'srh 4/22/2009 00:39'!
renderContentOn: html
	html div class: (self valid ifFalse: ['error']); with: [
		| id |
		id := html nextId.
		html label for: id; with: self label, ':'.
		(html perform: tag) 
			id: id;
			callback: [ :v| value := v];
			value: value].
		description ifNotNil: [html paragraph class: 'desc'; with: description].! !

!WSField methodsFor: 'actions' stamp: 'srh 6/26/2009 20:23'!
save
	receiver perform: selector asMutator with: self value! !

!WSField methodsFor: 'accessing' stamp: 'srh 12/30/2008 17:01'!
tagType: symbol
	tag := symbol! !

!WSField methodsFor: 'testing' stamp: 'srh 6/26/2009 20:24'!
valid
	^rules allSatisfy: [ :r | r  testRule: self value ].! !

!WSField methodsFor: 'accessing' stamp: 'srh 1/1/2009 20:55'!
value
	^value! !

WSField subclass: #WSFieldGroup
	instanceVariableNames: 'list labels newItemBlock componentBlock selectedItem'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Util'!

!WSFieldGroup methodsFor: 'actions' stamp: 'srh 3/8/2009 23:51'!
addItem: aTemplate
	value add: (self componentForItem: (self itemForTemplate: aTemplate))! !

!WSFieldGroup methodsFor: 'accessing' stamp: 'srh 3/8/2009 21:37'!
children
	^value select: [ :i | i isKindOf: WAComponent]! !

!WSFieldGroup methodsFor: 'accessing' stamp: 'srh 3/8/2009 23:41'!
component: aBlock
	componentBlock := aBlock! !

!WSFieldGroup methodsFor: 'actions' stamp: 'srh 3/9/2009 13:02'!
componentForItem: anItem
	^componentBlock
			ifNil: [ WSDisplayElement value: anItem ]
			ifNotNil: [ componentBlock value: anItem ]! !

!WSFieldGroup methodsFor: 'initialization' stamp: 'srh 3/9/2009 00:00'!
initialize
	value := OrderedCollection new.
	super initialize.! !

!WSFieldGroup methodsFor: 'actions' stamp: 'srh 3/8/2009 23:50'!
itemForTemplate: template
	^newItemBlock 
			ifNil: [ template ]
			ifNotNil: [ newItemBlock value: template ]! !

!WSFieldGroup methodsFor: 'accessing' stamp: 'srh 3/8/2009 09:58'!
labels: aBlock
	labels := aBlock! !

!WSFieldGroup methodsFor: 'accessing' stamp: 'srh 3/8/2009 09:46'!
list: anOrderedCollection
	list := OrderedCollection new addAll: anOrderedCollection; yourself! !

!WSFieldGroup methodsFor: 'accessing' stamp: 'srh 3/9/2009 12:30'!
messages
		| messages |
		messages := OrderedCollection new.
		value do: [:f | messages addAll: f messages ].
		^messages
! !

!WSFieldGroup methodsFor: 'accessing' stamp: 'srh 3/8/2009 23:40'!
newItem: aBlock 
	newItemBlock := aBlock! !

!WSFieldGroup methodsFor: 'actions' stamp: 'srh 3/9/2009 12:40'!
readInitialValue
	value := ((receiver perform: selector) collect: [ :i | self componentForItem: i]) asOrderedCollection! !

!WSFieldGroup methodsFor: 'actions' stamp: 'srh 3/8/2009 21:49'!
removeItem: anItem 
	^ value remove: anItem! !

!WSFieldGroup methodsFor: 'rendering' stamp: 'srh 3/9/2009 11:26'!
renderContentOn: html 
	html fieldSet: 
		[ | s |
		html legend: label.
		s := html select.
		s
			list: list;
			callback: [ :t | selectedItem := t ].
		labels ifNotNil: [ s labels: labels ].
		html submitButton
			value: 'Add';
			callback: [ self addItem: selectedItem ].
		self renderItemsOn: html ]! !

!WSFieldGroup methodsFor: 'rendering' stamp: 'srh 3/21/2009 21:22'!
renderItem: i on: html 
	^ html tableRow: 
		[ html tableData: i.
		html tableData: 
			[ html submitButton
				value: 'Remove';
				callback: [ self removeItem: i ] ] ]! !

!WSFieldGroup methodsFor: 'rendering' stamp: 'srh 3/21/2009 21:23'!
renderItemsOn: html 
	value isEmpty ifFalse: 
		[ html table: [ value do: [ :i | 
				self renderItem: i on: html ]]]! !

!WSFieldGroup methodsFor: 'rendering' stamp: 'srh 3/9/2009 12:10'!
save
	value do: [ :component | component save ].
	receiver perform: selector asMutator with: (value collect: [ :component | component value]).! !

!WSFieldGroup methodsFor: 'testing' stamp: 'srh 3/9/2009 12:13'!
valid
	^value allSatisfy: [ :i | i valid ]! !

WSField subclass: #WSImageField
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Util'!

!WSImageField class methodsFor: 'as yet unclassified' stamp: 'srh 12/30/2008 21:55'!
new
	^self basicNew
		tagType: #fileUpload;
		initialize;
		yourself.! !

!WSImageField methodsFor: 'initialization' stamp: 'srh 3/8/2009 21:43'!
readInitialValue
	"Can't do anything sensible here"
	! !

WSField subclass: #WSIntegerField
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Util'!

!WSIntegerField class methodsFor: 'as yet unclassified' stamp: 'srh 12/31/2008 10:24'!
new
	^self basicNew
		tagType: #textInput;
		initialize;
		yourself.! !

!WSIntegerField methodsFor: 'initialization' stamp: 'srh 6/28/2009 09:13'!
initialize
	super initialize.
	self addRule: [ :v | v isNil or: [v isInteger] ] withDescription: 'Must be a whole number'.! !

!WSIntegerField methodsFor: 'initialization' stamp: 'srh 3/8/2009 21:43'!
readInitialValue
	value := receiver perform: selector.
	value ifNotNil: [ value := value printString ]! !

!WSIntegerField methodsFor: 'actions' stamp: 'srh 3/9/2009 12:13'!
save
	receiver perform: selector asMutator with: value asInteger! !

WSField subclass: #WSMoneyField
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Util'!

!WSMoneyField class methodsFor: 'as yet unclassified' stamp: 'srh 12/30/2008 18:18'!
new
	^self basicNew
		tagType: #textInput;
		initialize;
		yourself.! !

!WSMoneyField methodsFor: 'initialization' stamp: 'srh 3/8/2009 21:43'!
readInitialValue
	value := receiver perform: selector.
	value ifNotNil: [ value := (value / 100) asFloat printString ]! !

!WSMoneyField methodsFor: 'actions' stamp: 'srh 3/9/2009 12:13'!
save
	receiver perform: selector asMutator with: ((value asNumber) * 100) asInteger! !

WSField subclass: #WSNumericField
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Util'!

!WSNumericField class methodsFor: 'as yet unclassified' stamp: 'srh 3/11/2009 14:42'!
new
	^self basicNew
		tagType: #textInput;
		initialize;
		yourself.! !

!WSNumericField methodsFor: 'initialization' stamp: 'srh 6/28/2009 09:27'!
initialize
	super initialize.
	self
		addRule: [:v | v isNil
				or: [[Number readExactlyFrom: v. true]
						on: Error
						do: [false]]]
		withDescription: 'Must be a number'! !

!WSNumericField methodsFor: 'initialization' stamp: 'srh 3/11/2009 14:42'!
readInitialValue
	value := receiver perform: selector.
	value ifNotNil: [ value := value printString ]! !

!WSNumericField methodsFor: 'actions' stamp: 'srh 3/11/2009 14:43'!
save
	receiver perform: selector asMutator with: value asNumber! !

WSFormElement subclass: #WSForm
	instanceVariableNames: 'fields'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Util'!

!WSForm methodsFor: 'adding' stamp: 'srh 1/1/2009 15:36'!
add: aField
	fields add: aField! !

!WSForm methodsFor: 'accessing' stamp: 'srh 1/1/2009 15:17'!
children
	^fields! !

!WSForm methodsFor: 'initialization' stamp: 'srh 3/8/2009 22:47'!
initialize
	super initialize.
	fields := OrderedCollection new.! !

!WSForm methodsFor: 'accessing' stamp: 'srh 3/21/2009 21:55'!
messages
	^ (rules reject: [ :r | r testRule: self ]) collect: [ :r | r message ]! !

!WSForm methodsFor: 'rendering' stamp: 'srh 5/22/2009 10:45'!
renderContentOn: html
	html div class: #form; with: [
	self renderMessagesOn: html.
	fields do: [:f | html render: f]].
! !

!WSForm methodsFor: 'rendering' stamp: 'srh 3/11/2009 21:16'!
renderMessagesOn: html 
	| messages |
	self valid ifTrue: [ ^ self ].
	messages := OrderedCollection new.
	messages addAll: self messages.
	fields do: [ :f | messages addAll: f messages ].
	html unorderedList class: 'error-msgs'; with: [ messages do: [ :m | html listItem: m ] ]! !

!WSForm methodsFor: 'actions' stamp: 'srh 3/9/2009 12:13'!
save
	fields do: [:f | f save]! !

!WSForm methodsFor: 'as yet unclassified' stamp: 'srh 3/8/2009 21:43'!
updateFromModel
	fields do: [ :f | f readInitialValue ]! !

!WSForm methodsFor: 'testing' stamp: 'srh 3/9/2009 12:13'!
valid
	^(fields allSatisfy: [:f | f valid]) and: [rules allSatisfy: [:r | r testRule: self]]! !

WSForm subclass: #WSOptionField
	instanceVariableNames: 'option'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Admin'!

!WSOptionField class methodsFor: 'as yet unclassified' stamp: 'srh 3/9/2009 00:02'!
option: anOption
	^self basicNew
		initializeWithOption: anOption;
		yourself! !

!WSOptionField methodsFor: 'as yet unclassified' stamp: 'srh 3/9/2009 12:14'!
initializeWithOption: anOption
	self initialize.
	option := anOption.
	self add: (WSLabel label: option class label).
	self add: (WSField text label: 'Name'; on: #name of: option; beRequired; yourself).
	self add: (WSField checkbox label: 'Required'; on: #required of: option; yourself).! !

!WSOptionField methodsFor: 'as yet unclassified' stamp: 'srh 3/9/2009 00:21'!
value
	^option! !

!WSFormElement methodsFor: 'adding' stamp: 'srh 3/8/2009 22:45'!
addRule: aBlock withDescription: desc.
	rules add: (WSRule rule: aBlock message: desc)! !

!WSFormElement methodsFor: 'adding' stamp: 'srh 3/8/2009 22:46'!
initialize
	super initialize.
	rules := OrderedCollection new.! !

!WSFormElement methodsFor: 'as yet unclassified' stamp: 'srh 3/8/2009 22:27'!
messages
	^#()! !

!WSFormElement methodsFor: 'as yet unclassified' stamp: 'srh 3/8/2009 22:21'!
save! !

!WSFormElement methodsFor: 'as yet unclassified' stamp: 'srh 3/8/2009 22:21'!
valid
	^true! !

WSFormElement subclass: #WSLabel
	instanceVariableNames: 'label'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Util'!

!WSLabel class methodsFor: 'as yet unclassified' stamp: 'srh 3/8/2009 22:23'!
label: aLabel
	^self basicNew
		initializeWithLabel: aLabel;
		yourself! !

!WSLabel methodsFor: 'as yet unclassified' stamp: 'srh 3/8/2009 22:25'!
initializeWithLabel: aLabel 
	self initialize.
	label := aLabel! !

!WSLabel methodsFor: 'as yet unclassified' stamp: 'srh 3/8/2009 22:23'!
renderContentOn: html 
	html label: label! !

WAComponent subclass: #WSIPNListener
	instanceVariableNames: 'fields response url'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Checkout'!

!WSIPNListener methodsFor: 'as yet unclassified' stamp: 'srh 7/13/2009 17:46'!
createUrlFor: aRequest
	url := WAUrl new.
	url scheme: #http. "http for now due to lack of SSL support in Squeak. Need to use stunnel to achieve https"
	url addToPath: '/us/cgi-bin/webscr'.
	url hostname: (self preferenceAt: #paypalIPNHost).
	url addParameter: 'cmd' value: '_notify-validate'.
	fields keysAndValuesDo: [ :key :value  | url addParameter: key value: value]! !

!WSIPNListener methodsFor: 'as yet unclassified' stamp: 'srh 7/13/2009 17:47'!
doIPNRequest: aRequest
	self createUrlFor: aRequest.
	response := url displayString asUrl retrieveContents.! !

!WSIPNListener methodsFor: 'as yet unclassified' stamp: 'srh 7/9/2009 19:56'!
initialRequest: aRequest
	fields := aRequest fields.
	self doIPNRequest: aRequest.! !

!WSIPNListener methodsFor: 'as yet unclassified' stamp: 'srh 7/13/2009 17:52'!
renderContentOn: html
	html div style: 'background-color: white'; with: [
	html heading: 'IPN Listener'.
	html heading level: 2; with: 'Parameters'.
	fields keysAndValuesDo: [ :key :value |
		html paragraph: key displayString, ' -> ', value displayString]].
	html heading level: 2; with: 'Url'.
	html paragraph: url displayString.
	html heading level: 2; with: 'Response'.
	html paragraph: response contents.! !

WAComponent subclass: #WSIPNLog
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Admin'!

!WSIPNLog class methodsFor: 'as yet unclassified' stamp: 'srh 7/19/2009 15:45'!
store: aStore
	^self basicNew
		initializeWithStore: aStore;
		yourself! !

WAComponent subclass: #WSImageEditor
	instanceVariableNames: 'image imageField'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Admin'!

!WSImageEditor class methodsFor: 'as yet unclassified' stamp: 'srh 2/5/2009 20:54'!
image: anImage
	^self basicNew
		initializeWithImage: anImage;
		yourself.! !

!WSImageEditor class methodsFor: 'as yet unclassified' stamp: 'srh 2/5/2009 20:54'!
new
	^self image: nil! !

!WSImageEditor methodsFor: 'as yet unclassified' stamp: 'srh 12/30/2008 21:57'!
children
	^Array with: imageField! !

!WSImageEditor methodsFor: 'as yet unclassified' stamp: 'srh 1/25/2009 15:07'!
imageFile: aWAFile
	aWAFile ifNotNil: [
		image := WSImage fromStream: (ReadStream on: aWAFile contents asByteArray)]! !

!WSImageEditor methodsFor: 'as yet unclassified' stamp: 'srh 2/5/2009 20:56'!
initializeWithImage: anImage
	self initialize.
	image := anImage.
	imageField := WSField image
		label: 'Select an Image';
		on: #imageFile of: self;
		yourself.
! !

!WSImageEditor methodsFor: 'as yet unclassified' stamp: 'srh 4/14/2009 12:15'!
renderContentOn: html
	html form multipart; with: [
		html render: imageField.
		html div: [
			html cancelButton callback: [self answer: nil]; value: 'Cancel'.
			html submitButton callback: [self save]; value: 'Preview'.
			html submitButton callback: [self saveAndAnswer]; value: 'Done'	
		]
	].
	image ifNotNil: [
		html div: [
			html wsImage: image thumbnail.
			html wsImage: image medium.
		]		
	]

! !

!WSImageEditor methodsFor: 'as yet unclassified' stamp: 'srh 1/26/2009 15:35'!
save
	imageField valid ifTrue: [(WSApplyFormCommand form: imageField) run].	! !

!WSImageEditor methodsFor: 'as yet unclassified' stamp: 'srh 12/30/2008 23:29'!
saveAndAnswer
	self save.
	self answer: image! !

WAComponent subclass: #WSImageManager
	instanceVariableNames: 'product'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Admin'!

!WSImageManager class methodsFor: 'as yet unclassified' stamp: 'srh 2/5/2009 20:55'!
for: aProduct
	^self basicNew
		initializeWithProduct: aProduct;
		yourself.! !

!WSImageManager methodsFor: 'as yet unclassified' stamp: 'cmd 3/21/2009 17:01'!
addImage: anImage
	anImage ifNotNil: [ (WSAddImageCommand product: product image: anImage) run].! !

!WSImageManager methodsFor: 'as yet unclassified' stamp: 'srh 1/26/2009 00:33'!
delete: anImage
	(WSDeleteImageCommand product: product image: anImage) run.
! !

!WSImageManager methodsFor: 'as yet unclassified' stamp: 'srh 2/5/2009 21:08'!
edit: anImage
	self call: (WSImageEditor image: anImage).
! !

!WSImageManager methodsFor: 'as yet unclassified' stamp: 'srh 2/5/2009 20:56'!
initializeWithProduct: aProduct.
	self initialize.
	product := aProduct.! !

!WSImageManager methodsFor: 'as yet unclassified' stamp: 'srh 1/25/2009 21:41'!
renderContentOn: html
	html anchor callback: [self addImage: (self call: WSImageEditor new)]; with: 'Add Image'.
	html text: ' '.
	html anchor callback: [self answer]; with: 'Done'.
	self renderImageListOn: html.! !

!WSImageManager methodsFor: 'as yet unclassified' stamp: 'srh 4/14/2009 12:15'!
renderImageListOn: html
	product images do: [:i |
		html div: [
			html div 
				class: (product preview = i ifTrue: ['preview']); 
				with: [html wsImage: i thumbnail].
			html div: [
				html anchor callback:  [product preview: i]; with: 'Set as Preview'.
				html text: ' '.
				html anchor callback: [self edit: i]; with: 'Edit'].
				html text: ' '.
				html anchor callback: [self delete: i]; with: 'Delete']]! !

WAComponent subclass: #WSMessageHistory
	instanceVariableNames: 'order'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Admin'!

!WSMessageHistory class methodsFor: 'as yet unclassified' stamp: 'srh 6/13/2009 16:00'!
order: anOrder
	^self basicNew
		initializeWithOrder: anOrder;
		yourself! !

!WSMessageHistory methodsFor: 'as yet unclassified' stamp: 'srh 6/13/2009 16:00'!
initializeWithOrder: anOrder
	self initialize.
	order := anOrder! !

!WSMessageHistory methodsFor: 'as yet unclassified' stamp: 'srh 6/13/2009 16:05'!
renderContentOn: html.
	html div: [
		order messages do: [ :m |
			self renderMessage: m on: html]]! !

!WSMessageHistory methodsFor: 'as yet unclassified' stamp: 'srh 6/13/2009 16:22'!
renderMessage: m on: html
	html definitionList: [
		html definitionTerm: 'Date: '.
		html definitionData: m date displayString.
		html definitionTerm: 'To: '.
		html definitionData: m recipient.
		html definitionTerm: 'Subject: '.
		html definitionData: m subject.
		html definitionTerm: 'Message'.
		html definitionData: m message.
	]! !

WAComponent subclass: #WSOrderDetails
	instanceVariableNames: 'order history currentItem options messages'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Admin'!

!WSOrderDetails class methodsFor: 'as yet unclassified' stamp: 'srh 4/27/2009 12:11'!
order: anOrder
	^self basicNew
		initializeWithOrder: anOrder;
		yourself! !

!WSOrderDetails methodsFor: 'as yet unclassified' stamp: 'srh 5/4/2009 17:53'!
children
	^Array with: history with: options.! !

!WSOrderDetails methodsFor: 'as yet unclassified' stamp: 'srh 5/2/2009 11:43'!
currentItem
	^currentItem! !

!WSOrderDetails methodsFor: 'as yet unclassified' stamp: 'srh 5/4/2009 17:55'!
currentItem: anItem
	currentItem := anItem.
	options := WSOrderOptionDetails item: anItem! !

!WSOrderDetails methodsFor: 'as yet unclassified' stamp: 'srh 6/13/2009 15:58'!
initializeWithOrder: anOrder
	self initialize.
	order := anOrder.
	self currentItem: order items items first.
	history := WSOrderHistory order: anOrder.
	messages := WSMessageHistory order: anOrder.! !

!WSOrderDetails methodsFor: 'as yet unclassified' stamp: 'srh 4/27/2009 12:13'!
renderActionsOn: html
	html div: [
		html anchor callback: [self answer]; with: 'Done']! !

!WSOrderDetails methodsFor: 'as yet unclassified' stamp: 'srh 5/2/2009 10:19'!
renderAddress: address on: html 
	html text: address name; break.
	html text: address address1; break.
	address address2 ifNotEmpty: [ html text: address address2; break ].
	html text: address locality; space; text: address state; space; text: address postcode; break.
	html text: address country.! !

!WSOrderDetails methodsFor: 'as yet unclassified' stamp: 'srh 6/13/2009 16:23'!
renderContentOn: html
	self renderActionsOn: html.
	self renderCustomerDetailsOn: html.
	self renderHistoryOn: html.
	self renderOrderOn: html.
	self renderDetailsOn: html.
	self renderMessagesOn: html.! !

!WSOrderDetails methodsFor: 'as yet unclassified' stamp: 'srh 5/2/2009 10:06'!
renderCustomerDetailsOn: html 
	html fieldSet
		class: 'customerDetails';
		with: 
			[ html legend: 'Customer Details'.
			html definitionList: 
				[ html definitionTerm: 'Name'.
				html definitionData: order customer name.
				html definitionTerm: 'Email'.
				html definitionData: order customer email.
				html definitionTerm: 'Ship To'.
				html definitionData: 
					[ self renderAddress: order address on: html ] ] ]! !

!WSOrderDetails methodsFor: 'as yet unclassified' stamp: 'srh 5/4/2009 18:00'!
renderDetailsOn: html
	html fieldSet: [
		html legend: 'Details - ', currentItem name.
		html render: options].! !

!WSOrderDetails methodsFor: 'as yet unclassified' stamp: 'srh 4/27/2009 12:28'!
renderHistoryOn: html
	html fieldSet class: 'history';with: [
		html legend: 'History'.
		html render: history]! !

!WSOrderDetails methodsFor: 'as yet unclassified' stamp: 'srh 6/13/2009 16:24'!
renderMessagesOn: html
	html fieldSet class: 'messages';with: [
		html legend: 'Message Log'.
		html render: messages]! !

!WSOrderDetails methodsFor: 'as yet unclassified' stamp: 'srh 5/2/2009 11:42'!
renderOrderOn: html
	html form: [
	html fieldSet: [
		html legend: 'Items'.
		html select size: 5; 
			beSubmitOnChange; 
			list: order items;
			on: #currentItem of: self;
			labels: [ :i | i name ]]]! !

WAComponent subclass: #WSOrderErrorPage
	instanceVariableNames: 'error'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Checkout'!

!WSOrderErrorPage class methodsFor: 'as yet unclassified' stamp: 'srh 1/3/2009 10:30'!
error: anException
	^self basicNew
		error: anException;
		initialize;
		yourself.! !

!WSOrderErrorPage methodsFor: 'as yet unclassified' stamp: 'srh 1/3/2009 10:30'!
error: anException
	error := anException! !

!WSOrderErrorPage methodsFor: 'as yet unclassified' stamp: 'srh 1/4/2009 20:52'!
renderContentOn: html
	html heading: 'Order Failed'.
	html paragraph: 'An error ocurred while processing your order: ', error printString.
	html div class: 'nav-buttons'; with: [ html anchor callback: [self answer]; with: 'Back']! !

WAComponent subclass: #WSOrderHistory
	instanceVariableNames: 'order'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Admin'!

!WSOrderHistory class methodsFor: 'as yet unclassified' stamp: 'srh 4/27/2009 12:30'!
order: anOrder
	^self basicNew
		initializeWithOrder: anOrder;
		yourself! !

!WSOrderHistory methodsFor: 'as yet unclassified' stamp: 'srh 4/27/2009 12:30'!
initializeWithOrder: anOrder
	self initialize.
	order := anOrder! !

!WSOrderHistory methodsFor: 'as yet unclassified' stamp: 'srh 4/27/2009 12:39'!
renderContentOn: html.
	html table: [
		html tableRow: [ html tableHeading: 'Date'; tableHeading: 'Status'; tableHeading: 'Details' ].
		order history do: [ :s |
			self renderStatus: s on: html]]! !

!WSOrderHistory methodsFor: 'as yet unclassified' stamp: 'srh 4/27/2009 12:36'!
renderStatus: aStatus on: html
	html tableRow: [
		html tableData: aStatus date displayString.
		html tableData: aStatus name asCapitalizedPhrase.
		html tableData: aStatus details]! !

WAComponent subclass: #WSOrderManager
	instanceVariableNames: 'filter store'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Admin'!

!WSOrderManager class methodsFor: 'as yet unclassified' stamp: 'srh 1/29/2009 13:47'!
store: aStore
	^self basicNew
		initializeWithStore: aStore;
		yourself.! !

!WSOrderManager methodsFor: 'as yet unclassified' stamp: 'srh 3/21/2009 21:28'!
confirmCancellation: anOrder 
	| reason |
	reason := self call: (WSCancelableInputDialog message: 'Please enter a reason for cancelling the order').
	^ reason ifNotNil: [ (WSCancelOrderCommand 
			order: anOrder
			reason: reason) run ]! !

!WSOrderManager methodsFor: 'as yet unclassified' stamp: 'srh 3/28/2009 23:01'!
formatDate: aDate
	^aDate asDate printFormat: #(3 2 1 $- 1 1 2) ! !

!WSOrderManager methodsFor: 'as yet unclassified' stamp: 'srh 2/2/2009 17:56'!
initializeWithStore: aStore
	store := aStore.
	self initialize.! !

!WSOrderManager methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 16:42'!
orders
	^filter isNil 
		ifTrue: [store orders]
		ifFalse: [store orders select: [ :o | o status is: filter ]].! !

!WSOrderManager methodsFor: 'as yet unclassified' stamp: 'srh 5/22/2009 10:39'!
renderActionsOn: html
	html div class: #actions; with: [
		html anchor callback: [self answer]; with: 'Done']! !

!WSOrderManager methodsFor: 'as yet unclassified' stamp: 'srh 3/21/2009 21:28'!
renderCancelActionFor: anOrder on: html 
	html anchor
		callback: [ self confirmCancellation: anOrder ];
		with: 'Cancel'! !

!WSOrderManager methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 17:10'!
renderConfirmedActionsFor: anOrder on: html
	html anchor callback: [(self confirm: 'Ship Order?') ifTrue: [(WSShipOrderCommand order: anOrder) run]]; with: 'Ship'.
	html space.
	self renderCancelActionFor: anOrder on: html! !

!WSOrderManager methodsFor: 'as yet unclassified' stamp: 'srh 2/2/2009 17:46'!
renderContentOn: html
	self renderActionsOn: html.
	self renderFilterOn: html.
	self renderOrderListOn: html! !

!WSOrderManager methodsFor: 'as yet unclassified' stamp: 'srh 3/8/2009 10:34'!
renderFilterOn: html
	html form: [ |id|
		id := html nextId.
		html label for: id; with: 'Show: '.
		html select 
			id: id; 
			beSubmitOnChange; 
			beOptional; 
			selected: filter;
			list: #(unconfirmed confirmed cancelled shipped);
			labels: [ :o | o asCapitalizedPhrase];
			optionalLabel: 'All';
			callback: [ :value | filter := value]]! !

!WSOrderManager methodsFor: 'as yet unclassified' stamp: 'srh 8/4/2009 16:00'!
renderOrderListOn: html 
	html table: 
		[ html tableRow: 
			[ html tableHeading: 'Reference'.
			html tableHeading: 'Customer'.
			html tableHeading: 'Items'.
			html tableHeading: 'Total'.
			html tableHeading: 'Date'.
			html tableHeading: 'Status' ].
		self orders do: 
			[ :o | 
			html tableRow: 
				[ html tableData: 
					[ html anchor
						callback: [ self viewOrder: o ];
						with: o reference ].
				html tableData: o customer name.
				html tableData: o items count printString.
				html tableData: '$' , o items totalInDollars.
				html tableData: (self formatDate: o date).
				html tableData: 
					[ self 
						renderStatus: o status
						on: html.
					self 
						renderStatusActionsFor: o
						on: html ] ] ] ]! !

!WSOrderManager methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 16:39'!
renderStatus: aStatus on: html.
	html text: aStatus name asCapitalizedPhrase, ' (', (self formatDate: aStatus date), ')'.
! !

!WSOrderManager methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 19:42'!
renderStatusActionsFor: anObject on: html
	| selector |
	selector := ('render', anObject status name displayString capitalized, 'ActionsFor:on:') asSymbol.
	(self respondsTo: selector) ifTrue: [
		self perform: selector with: anObject with: html]! !

!WSOrderManager methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 17:14'!
renderUnconfirmedActionsFor: anOrder on: html
	self renderCancelActionFor: anOrder on: html! !

!WSOrderManager methodsFor: 'as yet unclassified' stamp: 'srh 4/27/2009 12:10'!
viewOrder: anOrder
	self call: (WSOrderDetails order: anOrder)! !

WAComponent subclass: #WSOrderOptionDetails
	instanceVariableNames: 'components'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Admin'!

!WSOrderOptionDetails class methodsFor: 'as yet unclassified' stamp: 'srh 5/4/2009 17:56'!
item: anItem
	^self basicNew
		initializeWithItem: anItem;
		yourself.! !

!WSOrderOptionDetails methodsFor: 'as yet unclassified' stamp: 'srh 5/4/2009 17:51'!
children
	^components! !

!WSOrderOptionDetails methodsFor: 'as yet unclassified' stamp: 'srh 5/4/2009 17:55'!
initializeWithItem: anItem
	self initialize.
	components := anItem options collect: [ :o | o asComponent].! !

WAComponent subclass: #WSOrderSuccess
	instanceVariableNames: 'order'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Checkout'!

!WSOrderSuccess class methodsFor: 'as yet unclassified' stamp: 'srh 2/22/2009 14:31'!
order: anOrder
	^self basicNew
		initializeWithOrder: anOrder;
		yourself! !

!WSOrderSuccess methodsFor: 'as yet unclassified' stamp: 'srh 3/9/2009 11:13'!
initializeWithOrder: anOrder
	self initialize.
	order := anOrder.
! !

!WSOrderSuccess methodsFor: 'as yet unclassified' stamp: 'srh 2/22/2009 16:47'!
renderContentOn: html
	html heading: 'Order Complete'.
	html paragraph: 'Your order was succesfully placed, and your reference number is: ', order reference.
	html div class: 'nav-buttons'; with: [
		html anchor callback: [self answer]; with: 'Close']! !

WAComponent subclass: #WSPayPalCheckout
	instanceVariableNames: 'order onSuccess onCancel url'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Checkout'!

!WSPayPalCheckout class methodsFor: 'as yet unclassified' stamp: 'srh 2/21/2009 17:18'!
new
	^self shouldNotImplement! !

!WSPayPalCheckout class methodsFor: 'as yet unclassified' stamp: 'srh 2/22/2009 16:51'!
order: anOrder
	^self basicNew
		initializeWithOrder: anOrder
		yourself.! !

!WSPayPalCheckout methodsFor: 'as yet unclassified' stamp: 'srh 2/24/2009 21:15'!
initializeUrl
	url := WAUrl new.
	url scheme: #https.
	url addToPath: '/us/cgi-bin/webscr'.
	url hostname: (self preferenceAt: #paypalHost).
	url addParameter: 'business' value: (self preferenceAt: #accountEmail)! !

!WSPayPalCheckout methodsFor: 'as yet unclassified' stamp: 'srh 4/11/2009 20:03'!
initializeWithOrder: anOrder
	order := anOrder.
	onSuccess := [self answer: (self call: (WSOrderSuccess order: order))].
	onCancel := [self answer].
	self initializeUrl.
	self initialize.! !

!WSPayPalCheckout methodsFor: 'as yet unclassified' stamp: 'srh 2/24/2009 20:51'!
onCancel: aBlock
	onCancel := aBlock.! !

!WSPayPalCheckout methodsFor: 'as yet unclassified' stamp: 'srh 2/22/2009 16:52'!
onSuccess: aBlock
	onSuccess := aBlock.! !

!WSPayPalCheckout methodsFor: 'as yet unclassified' stamp: 'srh 6/27/2009 11:29'!
prepareUrlOn: html
	url addParameter: 'cmd' value: '_cart'.
	url addParameter: 'upload' value: '1'.
	url addParameter: 'address_override' value: '1'.
	url addParameter: 'business' value: (self preferenceAt: #accountEmail).
	url addParameter: 'currency_code' value: 'AUD'.
	url addParameter: 'first_name' value: (order customer name findTokens: ' ') first.
	url addParameter: 'last_name' value: (order customer name findTokens: ' ') last.
	url addParameter: 'address1' value: order address address1.
	url addParameter: 'address2' value: order address address2.
	url addParameter: 'city' value: order address locality.
	url addParameter: 'state' value: order address state.
	url addParameter: 'zip' value: order address postcode.
	url addParameter: 'country' value: order address country code.
	url addParameter: 'rm' value: '2'.
	url addParameter: 'return' value: (html urlForAction: onSuccess).
	url addParameter: 'cancel_return' value: (html urlForAction: onCancel).
	order items items inject: 1 into: [:index :product|
		url addParameter: 'amount_', index printString value: product priceInDollars.
		url addParameter: 'item_name_', index printString value: product name.
	index + 1].! !

!WSPayPalCheckout methodsFor: 'as yet unclassified' stamp: 'srh 2/24/2009 21:26'!
renderContentOn: html
	self prepareUrlOn: html.
	self session redirectTo: url displayString.! !

WAComponent subclass: #WSProductEditor
	instanceVariableNames: 'product fields'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Admin'!

!WSProductEditor class methodsFor: 'as yet unclassified' stamp: 'srh 2/5/2009 20:49'!
new
	^self product: (WSProduct new).! !

!WSProductEditor class methodsFor: 'as yet unclassified' stamp: 'srh 2/5/2009 20:49'!
product: aProduct
	^self basicNew
		initializeWithProduct: aProduct;
		initialize;
		yourself.! !

!WSProductEditor methodsFor: 'as yet unclassified' stamp: 'srh 1/1/2009 15:19'!
children
	^Array with: fields! !

!WSProductEditor methodsFor: 'as yet unclassified' stamp: 'srh 2/5/2009 20:47'!
initializeWithProduct: aProduct
	self initialize.
	product := aProduct.
	self setupFields.! !

!WSProductEditor methodsFor: 'as yet unclassified' stamp: 'srh 1/1/2009 15:20'!
renderContentOn: html
	html form: [
		html render: fields.
		html div: [
			html cancelButton value: 'Cancel'; callback: [ self answer: nil].
			html submitButton value: 'Save'; callback: [ self saveAndAnswer]
	]]! !

!WSProductEditor methodsFor: 'as yet unclassified' stamp: 'srh 3/21/2009 21:56'!
saveAndAnswer
	fields valid ifFalse: [ ^ self ].
	(WSApplyFormCommand form: fields) run.
	self answer: product! !

!WSProductEditor methodsFor: 'as yet unclassified' stamp: 'srh 3/8/2009 23:46'!
setupFields
	fields := WSForm new.
	fields add: (WSField text
			label: 'Name';
			on: #name
				of: product;
			beRequired).
	fields add: (WSField money
			label: 'Price';
			on: #price
				of: product;
			beRequired).
	fields add: (WSField largeText
			label: 'Description';
			on: #description
				of: product).
	fields add: (WSFieldGroup new
			label: 'Product Specific Fields';
			list: WSOption subclasses;
			labels: [ :item | item label ];
			newItem: [ :template | template new ];
			component: [ :item | WSOptionField option: item ];
			on: #options
				of: product)! !

WAComponent subclass: #WSProductManager
	instanceVariableNames: 'store'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Admin'!

!WSProductManager class methodsFor: 'as yet unclassified' stamp: 'srh 2/5/2009 20:49'!
store: aStore
	^self basicNew
		initializeWithStore: aStore;
		yourself! !

!WSProductManager methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 21:43'!
addProduct
	| p |
	p := self call: WSProductEditor new.
	p ifNotNil: [	(WSAddProductCommand store: store product: p) run]! !

!WSProductManager methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 21:44'!
deleteProduct: p
	(self confirm: 'Really delete ',p name, '?') ifTrue: [
		(WSDeleteProductCommand store: store product: p) run ]! !

!WSProductManager methodsFor: 'as yet unclassified' stamp: 'srh 12/30/2008 20:01'!
editProduct: aProduct 
	self call: (WSProductEditor product: aProduct)! !

!WSProductManager methodsFor: 'as yet unclassified' stamp: 'srh 2/5/2009 20:51'!
initializeWithStore: aStore
	self initialize.
	store := aStore! !

!WSProductManager methodsFor: 'as yet unclassified' stamp: 'srh 12/30/2008 20:24'!
manageImages: aProduct
	self call: (WSImageManager for: aProduct)! !

!WSProductManager methodsFor: 'as yet unclassified' stamp: 'srh 5/19/2009 20:46'!
renderActionsOn: html
	html div class: #actions; with: [
		html anchor callback: [ self addProduct]; with: 'Add Product'.
		html text: ' '.
		html anchor callback: [self answer]; with: 'Done']! !

!WSProductManager methodsFor: 'as yet unclassified' stamp: 'srh 5/22/2009 10:40'!
renderContentOn: html
	html div id: #pm; with: [
	self renderActionsOn: html.
	self renderStatsOn: html.
	self renderProductListOn: html]! !

!WSProductManager methodsFor: 'as yet unclassified' stamp: 'srh 8/4/2009 15:37'!
renderProductListOn: html 
	html table: 
		[ html tableRow: 
			[ html tableHeading.
			html tableHeading: 'Name'.
			html tableHeading: 'Price'.
			html tableHeading: 'Actions' ].
		store products do: 
			[ :p | 
			html tableRow: 
				[ html tableData: [ p preview ifNotNil: [ html wsImage: p preview thumbnail ] ].
				html tableData: p name.
				html tableData: p priceInDollars.
				html tableData: 
					[ html anchor
						callback: [ self deleteProduct: p ];
						with: 'Delete'.
					html space.
					html anchor
						callback: [ self editProduct: p ];
						with: 'Edit'.
					html space.
					html anchor
						callback: [ self manageImages: p ];
						with: 'Images'.
					html space.
					p enabled 
						ifTrue: 
							[ html anchor
								callback: [ (WSDisableProductCommand product: p) run ];
								with: 'Disable' ]
						ifFalse: 
							[ html anchor
								callback: [ (WSEnableProductCommand product: p) run ];
								with: 'Enable' ] ] ] ] ]! !

!WSProductManager methodsFor: 'as yet unclassified' stamp: 'srh 5/19/2009 20:47'!
renderStatsOn: html
	html div class: #stats; with: [
		html paragraph: store products size printString, ' products']! !

WAComponent subclass: #WSRoot
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Util'!

!WSRoot methodsFor: 'as yet unclassified' stamp: 'srh 3/21/2009 11:36'!
addListener: aListener
	aListener handles do: [ :a |
		self session on: a do: [ :ann |  aListener do: ann ]]! !

!WSRoot methodsFor: 'as yet unclassified' stamp: 'srh 3/21/2009 12:22'!
initialize
	super initialize.
	self addListener: (WSLightboxListener root: self).! !

WAComponent subclass: #WSStoreAdmin
	instanceVariableNames: 'store'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Admin'!

!WSStoreAdmin class methodsFor: 'as yet unclassified' stamp: 'srh 12/30/2008 11:51'!
canBeRoot
	^true! !

!WSStoreAdmin class methodsFor: 'as yet unclassified' stamp: 'srh 3/30/2009 13:37'!
isDeployed
	^true! !

!WSStoreAdmin methodsFor: 'as yet unclassified' stamp: 'srh 1/24/2009 21:57'!
initialize
	super initialize.
	store := self session store.! !

!WSStoreAdmin methodsFor: 'as yet unclassified' stamp: 'srh 3/21/2009 21:19'!
manageOrders
	self call: (WSOrderManager store: store)! !

!WSStoreAdmin methodsFor: 'as yet unclassified' stamp: 'srh 3/21/2009 21:18'!
manageProducts
	self call: (WSProductManager store: store) ! !

!WSStoreAdmin methodsFor: 'as yet unclassified' stamp: 'srh 1/3/2009 09:49'!
menu: title callback: aBlock on: html
	html heading level: 2; with: [
	html anchor 
		callback: aBlock; 
		with: title].
! !

!WSStoreAdmin methodsFor: 'as yet unclassified' stamp: 'srh 5/28/2009 16:14'!
migrateStore
	self session magmaSession commit: [store migrate].
	self inform: 'Migration Successful'! !

!WSStoreAdmin methodsFor: 'as yet unclassified' stamp: 'srh 8/4/2009 19:43'!
renderConfigurationOn: html 
	html fieldSet
		legend: 'Configuration';
		with: [ self
				menu: 'Store Configuration'
				callback: [self storeConfiguration]
				on: html. ]! !

!WSStoreAdmin methodsFor: 'as yet unclassified' stamp: 'srh 7/19/2009 15:28'!
renderContentOn: html 
	html div id: 'home';
		with: [self renderStoreManagementOn: html.
			self renderReportsOn: html.
			self renderConfigurationOn: html.
			self renderSystemMaintenanceOn: html]! !

!WSStoreAdmin methodsFor: 'as yet unclassified' stamp: 'srh 7/19/2009 15:32'!
renderReportsOn: html 
	html fieldSet
		legend: 'Reports';
		with: [self menu: 'IPN Log' callback: [ self showIPNLog ] on: html.		 ]! !

!WSStoreAdmin methodsFor: 'as yet unclassified' stamp: 'srh 7/19/2009 15:25'!
renderStoreManagementOn: html 
	html fieldSet legend: 'Manage Store';
		with: [self
				menu: 'Manage Products'
				callback: [self manageProducts]
				on: html.
			self
				menu: 'Manage Orders'
				callback: [self manageOrders]
				on: html]! !

!WSStoreAdmin methodsFor: 'as yet unclassified' stamp: 'srh 7/19/2009 15:27'!
renderSystemMaintenanceOn: html 
	html fieldSet legend: 'System Maintenance';
		with: [self
				menu: 'Migrate Store'
				callback: [self migrateStore]
				on: html.
			self
				menu: 'Reset Store'
				callback: [self resetStore]
				on: html]! !

!WSStoreAdmin methodsFor: 'as yet unclassified' stamp: 'srh 3/1/2009 18:58'!
resetStore
	(self confirm: 'This will Delete the entire store and cannot be undone - are you sure?') ifTrue: [
		self session magmaSession commit: [ self session magmaSession root at: #store put: WSStore new]]! !

!WSStoreAdmin methodsFor: 'as yet unclassified' stamp: 'srh 7/19/2009 15:45'!
showIPNLog
	self call: (WSIPNLog store: store)! !

!WSStoreAdmin methodsFor: 'as yet unclassified' stamp: 'srh 8/4/2009 19:44'!
storeConfiguration
	self call: (WSStoreConfiguration store: store) ! !

WAComponent subclass: #WSStoreConfiguration
	instanceVariableNames: 'form store localShipping internationalShipping'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Admin'!

!WSStoreConfiguration class methodsFor: 'as yet unclassified' stamp: 'srh 8/4/2009 19:30'!
store: aStore
	^self basicNew
		initializeWithStore: aStore;
		yourself! !

!WSStoreConfiguration methodsFor: 'as yet unclassified' stamp: 'srh 8/4/2009 19:32'!
children
	^Array with: form! !

!WSStoreConfiguration methodsFor: 'as yet unclassified' stamp: 'srh 8/15/2009 10:05'!
initializeFormFields
	form := WSForm new.
	form add: (WSNumericField new 
		label: 'Local Shipping';
		on: #localShipping of: store;
		beRequired;
		yourself).
	form add: (WSNumericField new 
		label: 'International Shipping';
		on: #internationalShipping of: store;
		beRequired;
		yourself)! !

!WSStoreConfiguration methodsFor: 'as yet unclassified' stamp: 'srh 8/4/2009 19:31'!
initializeWithStore: aStore
	self initialize.
	store :=  aStore.
	self initializeFormFields! !

!WSStoreConfiguration methodsFor: 'as yet unclassified' stamp: 'srh 8/15/2009 10:07'!
renderContentOn: html
	html heading: 'Store Configuration'.
	html form: [
		html render: form.
		html cancelButton callback: [ self answer ]; value: 'Cancel'.
		html submitButton callback: [ self save ]; value: 'Save'.
	]! !

!WSStoreConfiguration methodsFor: 'as yet unclassified' stamp: 'srh 8/14/2009 21:02'!
save
	form valid ifTrue: [
		form save.
		self answer.
	]! !

WAComponent subclass: #WSWizardPage
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Util'!

WSWizardPage subclass: #WSBaseAddressPage
	instanceVariableNames: 'fields tempAddress'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Checkout'!

!WSBaseAddressPage methodsFor: 'as yet unclassified' stamp: 'srh 1/1/2009 18:21'!
addressClass
	^WSAddress! !

!WSBaseAddressPage methodsFor: 'as yet unclassified' stamp: 'srh 1/1/2009 18:13'!
children
	^Array with:fields! !

!WSBaseAddressPage methodsFor: 'as yet unclassified' stamp: 'srh 1/1/2009 18:21'!
initialize
	super initialize.
	tempAddress := self addressClass new.
	fields := WSForm new.
	self setupFields! !

!WSBaseAddressPage methodsFor: 'as yet unclassified' stamp: 'srh 6/20/2009 10:50'!
setupFields
	fields add: (WSField text 
		label: 'Address Line 1';
		on: #address1 of: tempAddress;
		beRequired;
		yourself).
	fields add: (WSField text 
		label: 'Address Line 2';
		on: #address2 of: tempAddress;
		yourself).
	fields add: (WSField text
		label: 'Suburb / Town';
		on: #locality of: tempAddress;
		yourself).
	fields add: (WSField text
		label: 'State / Province';
		on: #state of: tempAddress;
		beRequired;
		yourself).
	fields add: (WSField text
		label: 'Postcode';
		on: #postcode of: tempAddress;
		beRequired; 
		yourself).
	fields add: (WSCountryField new
		label: 'Country';
		on: #country of: tempAddress;
		beRequired; 
		yourself).! !

WSBaseAddressPage subclass: #WSShippingAddressPage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Checkout'!

!WSShippingAddressPage methodsFor: 'as yet unclassified' stamp: 'srh 1/1/2009 18:22'!
addressClass
	^WSShippingAddress! !

!WSShippingAddressPage methodsFor: 'as yet unclassified' stamp: 'srh 1/1/2009 20:35'!
enabled
	^model customer notNil! !

!WSShippingAddressPage methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 16:51'!
onEnter
	model address ifNil: [
		tempAddress name: model customer name.
		fields updateFromModel.
	]! !

!WSShippingAddressPage methodsFor: 'as yet unclassified' stamp: 'srh 1/1/2009 18:33'!
renderContentOn: html
	html div class: 'shipping-address'; with: fields.	! !

!WSShippingAddressPage methodsFor: 'as yet unclassified' stamp: 'srh 1/1/2009 16:41'!
save
	fields valid 
		ifTrue: [
			fields save.
			model address: tempAddress.
			^true]
		ifFalse: [^false]! !

!WSShippingAddressPage methodsFor: 'as yet unclassified' stamp: 'srh 1/1/2009 18:23'!
setupFields
	fields add: (WSField text 
		label: 'Name';
		on: #name of: tempAddress;
		beRequired).
	super setupFields.! !

!WSShippingAddressPage methodsFor: 'as yet unclassified' stamp: 'srh 1/1/2009 21:26'!
title
	^'Shipping Address'! !

!WSShippingAddressPage methodsFor: 'as yet unclassified' stamp: 'srh 1/1/2009 16:40'!
valid
	^model address notNil.! !

WSWizardPage subclass: #WSCartViewPage
	instanceVariableNames: 'cartView'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Checkout'!

!WSCartViewPage methodsFor: 'as yet unclassified' stamp: 'srh 1/4/2009 18:57'!
children
	^Array with: cartView! !

!WSCartViewPage methodsFor: 'as yet unclassified' stamp: 'srh 1/1/2009 13:53'!
enabled
	^true! !

!WSCartViewPage methodsFor: 'as yet unclassified' stamp: 'srh 1/4/2009 15:01'!
model: anObject
	super model: anObject.
	cartView := WSCartView cart: model items! !

!WSCartViewPage methodsFor: 'as yet unclassified' stamp: 'srh 1/1/2009 13:22'!
renderContentOn: html
	html render: cartView! !

!WSCartViewPage methodsFor: 'as yet unclassified' stamp: 'srh 1/1/2009 13:19'!
title
	^'Review Order'! !

!WSCartViewPage methodsFor: 'as yet unclassified' stamp: 'srh 6/28/2009 22:25'!
valid
	^cartView cart isEmpty not! !

WSWizardPage subclass: #WSConfirmOrderPage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Checkout'!

!WSConfirmOrderPage methodsFor: 'as yet unclassified' stamp: 'srh 1/1/2009 16:40'!
enabled
	^model address notNil! !

!WSConfirmOrderPage methodsFor: 'as yet unclassified' stamp: 'srh 6/27/2009 11:26'!
renderAddress: anAddress on: html
	html
		definitionTerm: 'Address';
		definitionData: [
			html text: anAddress address1.
			anAddress address2 ifNotNil: [
				html break; text: anAddress address2.
			].
			html
				text: anAddress locality, ' ', anAddress state, ' ', anAddress postcode; break;
				text: anAddress country name]! !

!WSConfirmOrderPage methodsFor: 'as yet unclassified' stamp: 'srh 1/1/2009 21:40'!
renderContentOn: html
	html div id: 'confirm-order'; with: [
		html div: [self renderOrderSummaryOn: html].			
		html div: [self renderCustomerDetailsOn: html].			
		html div: [self renderShippingOn: html].
	]! !

!WSConfirmOrderPage methodsFor: 'as yet unclassified' stamp: 'srh 2/22/2009 12:07'!
renderCustomerDetailsOn: html
	html heading level: 2; with: 'Customer Details'.
	html definitionList: [
		html 
			definitionTerm: 'Name';
			definitionData: model customer name;
			definitionTerm: 'Email';
			definitionData: model customer email.
	]! !

!WSConfirmOrderPage methodsFor: 'as yet unclassified' stamp: 'srh 8/4/2009 16:00'!
renderOrderSummaryOn: html 
	html heading
		level: 2;
		with: 'Order'.
	html paragraph: self session cart count printString , ' items, for a total of $' , self session cart totalInDollars! !

!WSConfirmOrderPage methodsFor: 'as yet unclassified' stamp: 'srh 1/1/2009 21:38'!
renderShippingOn: html
	html heading level: 2; with: 'Shipping To:'.
	html definitionList: [
		html 
			definitionTerm: 'Name';
			definitionData: model address name.
		self renderAddress: model address on: html
	]! !

!WSConfirmOrderPage methodsFor: 'as yet unclassified' stamp: 'srh 1/1/2009 13:19'!
title
	^'Confirm Purchase'! !

!WSConfirmOrderPage methodsFor: 'as yet unclassified' stamp: 'srh 1/1/2009 16:03'!
valid
	^true! !

WSWizardPage subclass: #WSCustomerPage
	instanceVariableNames: 'tempCustomer email2 fields'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Checkout'!

!WSCustomerPage methodsFor: 'as yet unclassified' stamp: 'srh 2/22/2009 12:02'!
children
	^Array with:fields! !

!WSCustomerPage methodsFor: 'as yet unclassified' stamp: 'srh 1/1/2009 20:31'!
email2
	^email2! !

!WSCustomerPage methodsFor: 'as yet unclassified' stamp: 'srh 1/1/2009 20:32'!
email2: anEmail
	email2 := anEmail! !

!WSCustomerPage methodsFor: 'as yet unclassified' stamp: 'srh 1/1/2009 18:26'!
enabled
	^true! !

!WSCustomerPage methodsFor: 'as yet unclassified' stamp: 'srh 2/22/2009 12:01'!
initialize
	super initialize.
	tempCustomer := WSCustomer new.
	fields := WSForm new.
	self setupFields.! !

!WSCustomerPage methodsFor: 'as yet unclassified' stamp: 'srh 1/1/2009 18:29'!
renderContentOn: html
	html div class: 'customer-details'; with: fields.	! !

!WSCustomerPage methodsFor: 'as yet unclassified' stamp: 'srh 1/1/2009 20:59'!
save
	fields valid 
		ifTrue: [
			fields save.
			model customer: tempCustomer.
			^true]
		ifFalse: [^false]! !

!WSCustomerPage methodsFor: 'as yet unclassified' stamp: 'srh 2/22/2009 12:01'!
setupFields
	| email1Field email2Field |
	fields add: (WSField text 
		label: 'Name';
		on: #name of: tempCustomer;
		beRequired).
	email1Field :=  (WSField text 
		label: 'Email';
		on: #email of: tempCustomer;
		beRequired).
	email2Field := (WSField text 
		label: 'Confirm Email';
		on: #email2 of: self;
		beRequired).
	fields add:email1Field.
	fields add: email2Field.
	fields addRule: [ :v | email1Field value = email2Field value] withDescription: 'Email addresses don''t match'.! !

!WSCustomerPage methodsFor: 'as yet unclassified' stamp: 'srh 1/1/2009 18:31'!
title
	^'Customer Details'! !

!WSCustomerPage methodsFor: 'as yet unclassified' stamp: 'srh 1/1/2009 20:59'!
valid
	^fields valid! !

!WSWizardPage methodsFor: 'as yet unclassified' stamp: 'srh 1/1/2009 16:38'!
enabled
	^false! !

!WSWizardPage methodsFor: 'as yet unclassified' stamp: 'srh 1/1/2009 16:38'!
model: anObject
	model := anObject! !

!WSWizardPage methodsFor: 'as yet unclassified' stamp: 'srh 1/1/2009 18:58'!
onEnter! !

!WSWizardPage methodsFor: 'as yet unclassified' stamp: 'srh 1/1/2009 14:32'!
save
	"Attempt to save the data on the page, return success or failure"
	^true! !

!WSWizardPage methodsFor: 'as yet unclassified' stamp: 'srh 1/1/2009 12:54'!
title
	^self subclassResponsibility.! !

!WSWizardPage methodsFor: 'as yet unclassified' stamp: 'srh 1/1/2009 15:55'!
valid
	^false! !

Object subclass: #WSCommand
	instanceVariableNames: 'transactionProvider'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Commands'!

!WSCommand commentStamp: 'srh 6/28/2009 21:50' prior: 0!
A WSCommand is a base class for implementing Commands.
A command is a single unit of work within the system, and operates within a transaction.
If a command throws an exception, the transaction will be rolled back.

Instance Variables
	transactionProvider:		<Object>

transactionProvider
	- An object that implements #commit: and #abort.  The default implementation pulls it from the Seaside session, and assumes it's available as #magmaSession
!

WSCommand subclass: #WSAddProductCommand
	instanceVariableNames: 'store product'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Commands'!

!WSAddProductCommand class methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 21:40'!
store: aStore product: aProduct 
	^self basicNew
		initializeWithStore: aStore product: aProduct;
		yourself.! !

!WSAddProductCommand methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 21:41'!
do
	store addProduct: product.! !

!WSAddProductCommand methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 21:41'!
initializeWithStore: aStore product: aProduct
	store := aStore.
	product := aProduct.
	self initialize.! !

WSCommand subclass: #WSApplyFormCommand
	instanceVariableNames: 'form'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Commands'!

!WSApplyFormCommand class methodsFor: 'as yet unclassified' stamp: 'srh 1/26/2009 14:20'!
form: aForm
	^self basicNew
		initializeWithForm: aForm;
		yourself! !

!WSApplyFormCommand methodsFor: 'as yet unclassified' stamp: 'srh 1/26/2009 14:29'!
do
	form save.! !

!WSApplyFormCommand methodsFor: 'as yet unclassified' stamp: 'srh 1/26/2009 14:20'!
initializeWithForm: aForm
	form := aForm.
	self initialize.! !

WSCommand subclass: #WSCancelOrderCommand
	instanceVariableNames: 'order reason'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Commands'!

!WSCancelOrderCommand class methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 20:56'!
order: anOrder reason: aReason
	^self basicNew
		initializeWithOrder: anOrder reason: aReason;
		yourself! !

!WSCancelOrderCommand methodsFor: 'as yet unclassified' stamp: 'srh 6/13/2009 18:51'!
do
	order cancel: reason.! !

!WSCancelOrderCommand methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 20:56'!
initializeWithOrder: anOrder reason: aReason.
	self initialize.
	order := anOrder.
	reason := aReason.! !

!WSCommand class methodsFor: 'as yet unclassified' stamp: 'srh 1/25/2009 22:15'!
new
	self shouldNotImplement! !

!WSCommand methodsFor: 'as yet unclassified' stamp: 'srh 1/25/2009 22:05'!
do
	"Override this to actually do something"! !

!WSCommand methodsFor: 'initialization' stamp: 'srh 4/19/2009 23:12'!
initialize
	transactionProvider := WSCurrentTransactionProvider value.! !

!WSCommand methodsFor: 'processing' stamp: 'srh 3/21/2009 21:41'!
run
	[transactionProvider
		commit: [self do]]
		on: Error
		do: [:e | 
			transactionProvider abort.
			e signal]! !

WSCommand subclass: #WSDeleteProductCommand
	instanceVariableNames: 'store product'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Commands'!

!WSDeleteProductCommand class methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 21:40'!
store: aStore product: aProduct 
	^self basicNew
		initializeWithStore: aStore product: aProduct;
		yourself.! !

!WSDeleteProductCommand methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 21:42'!
do
	store deleteProduct: product! !

!WSDeleteProductCommand methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 21:41'!
initializeWithStore: aStore product: aProduct
	store := aStore.
	product := aProduct.
	self initialize.! !

WSCommand subclass: #WSPlaceOrderCommand
	instanceVariableNames: 'store order'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Commands'!

!WSPlaceOrderCommand class methodsFor: 'as yet unclassified' stamp: 'srh 1/26/2009 21:22'!
store: aStore order: anOrder
	^self basicNew
		initializeWithStore: aStore order: anOrder;
		yourself! !

!WSPlaceOrderCommand methodsFor: 'as yet unclassified' stamp: 'srh 6/13/2009 18:50'!
do
	store placeOrder: order.! !

!WSPlaceOrderCommand methodsFor: 'as yet unclassified' stamp: 'srh 1/26/2009 21:23'!
initializeWithStore: aStore order: anOrder
	store := aStore.
	order := anOrder.
	self initialize.
! !

WSCommand subclass: #WSProductCommand
	instanceVariableNames: 'product'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Commands'!

WSProductCommand subclass: #WSAddImageCommand
	instanceVariableNames: 'image'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Commands'!

!WSAddImageCommand class methodsFor: 'as yet unclassified' stamp: 'srh 1/26/2009 13:36'!
product: aProduct image: anImage
	^self basicNew
		initializeWithProduct: aProduct image: anImage;
		yourself! !

!WSAddImageCommand methodsFor: 'as yet unclassified' stamp: 'srh 1/26/2009 13:37'!
do
	product addImage: image! !

!WSAddImageCommand methodsFor: 'initialization' stamp: 'srh 1/26/2009 13:36'!
initializeWithProduct: aProduct image: anImage
	image := anImage.
	self initializeWithProduct: aProduct.
	! !

WSProductCommand subclass: #WSDeleteImageCommand
	instanceVariableNames: 'image'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Commands'!

!WSDeleteImageCommand class methodsFor: 'as yet unclassified' stamp: 'srh 1/25/2009 22:17'!
product: aProduct image: anImage
	^self basicNew
		initializeWithProduct: aProduct image: anImage;
		yourself! !

!WSDeleteImageCommand methodsFor: 'as yet unclassified' stamp: 'srh 1/25/2009 22:19'!
do
	product removeImage: image! !

!WSDeleteImageCommand methodsFor: 'initialization' stamp: 'srh 1/25/2009 23:03'!
initializeWithProduct: aProduct image: anImage
	image := anImage.
	self initializeWithProduct: aProduct.
	! !

WSProductCommand subclass: #WSDisableProductCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Commands'!

!WSDisableProductCommand class methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 21:39'!
product: aProduct
	^self basicNew
		initializeWithProduct: aProduct;
		yourself.! !

!WSDisableProductCommand methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 21:38'!
do
	product disable! !

WSProductCommand subclass: #WSEnableProductCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Commands'!

!WSEnableProductCommand class methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 21:39'!
product: aProduct
	^self basicNew
		initializeWithProduct: aProduct;
		yourself.! !

!WSEnableProductCommand methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 21:38'!
do
	product enable! !

!WSProductCommand methodsFor: 'initialization' stamp: 'srh 1/25/2009 22:16'!
initializeWithProduct: aProduct
	product := aProduct.
	self initialize.
! !

WSProductCommand subclass: #WSSetPreviewCommand
	instanceVariableNames: 'image'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Commands'!

!WSSetPreviewCommand class methodsFor: 'as yet unclassified' stamp: 'srh 1/26/2009 13:36'!
product: aProduct image: anImage
	^self basicNew
		initializeWithProduct: aProduct image: anImage;
		yourself! !

!WSSetPreviewCommand methodsFor: 'as yet unclassified' stamp: 'srh 1/26/2009 13:37'!
do
	product preview: image! !

!WSSetPreviewCommand methodsFor: 'initialization' stamp: 'srh 1/26/2009 13:36'!
initializeWithProduct: aProduct image: anImage
	image := anImage.
	self initializeWithProduct: aProduct.
	! !

WSCommand subclass: #WSShipOrderCommand
	instanceVariableNames: 'order'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Commands'!

!WSShipOrderCommand class methodsFor: 'as yet unclassified' stamp: 'srh 2/5/2009 21:53'!
order: anOrder
	^self basicNew
		initializeWithOrder: anOrder;
		yourself! !

!WSShipOrderCommand methodsFor: 'as yet unclassified' stamp: 'srh 6/13/2009 18:52'!
do
	order ship.
! !

!WSShipOrderCommand methodsFor: 'as yet unclassified' stamp: 'srh 2/5/2009 21:54'!
initializeWithOrder: anOrder
	self initialize.
	order := anOrder! !

Object subclass: #WSConnectionPool
	instanceVariableNames: 'location minFree maximum sessions enabled activeSessions activeSema highWater'
	classVariableNames: 'Pools'
	poolDictionaries: ''
	category: 'WebStore-MagmaPools'!

!WSConnectionPool commentStamp: 'srh 6/28/2009 21:50' prior: 0!
A WSConnectionPool is a Connection pool for MagmaSessions.

Instance Variables
	activeSema:		<Semaphore> 
	activeSessions:		<IdentitySet> 
	enabled:		<Boolean> 
	highWater:		<Integer> 
	location:		<MagmaLocation> 
	maximum:		<Object>
	minFree:		<Object>
	sessions:		<Object>

activeSema
	- protects access to the activeSessions set

activeSessions
	- a set containing the active sessions

enabled
	- whether or not this pool is enabled

highWater
	- the number of free sessions above which returned sessions will be discarded.

location
	- the MagmaLocation from which to obtain new sessions

maximum
	- the hard maximum number of sessions to make available - requests will block until a session is returned when this is hit

minFree
	- the minimum number of sessions to keep on hand.

sessions
	- the available sessions
!

!WSConnectionPool class methodsFor: 'as yet unclassified' stamp: 'srh 4/19/2009 23:27'!
initialize
	Pools := Dictionary new.
	Smalltalk addToStartUpList: self.
	Smalltalk addToShutDownList: self.! !

!WSConnectionPool class methodsFor: 'as yet unclassified' stamp: 'srh 4/19/2009 23:34'!
at: aSymbol
	^Pools at: aSymbol! !

!WSConnectionPool class methodsFor: 'as yet unclassified' stamp: 'srh 4/19/2009 21:14'!
newWithLocation: aLocation
	^self basicNew
		initializeWithLocation: aLocation;
		yourself.! !

!WSConnectionPool class methodsFor: 'as yet unclassified' stamp: 'srh 4/19/2009 23:29'!
register: aLocation withName: aSymbol
	Pools at: aSymbol ifPresent: [ :pool | pool shutDown].
	(Pools at: aSymbol put: (self newWithLocation: aLocation)) startUp.! !

!WSConnectionPool class methodsFor: 'as yet unclassified' stamp: 'srh 4/19/2009 22:46'!
remove: aSymbol
	Pools at: aSymbol ifPresent: [ :p |
		p shutDown.
		Pools remove: aSymbol ].! !

!WSConnectionPool class methodsFor: 'as yet unclassified' stamp: 'srh 4/19/2009 22:46'!
shutDown
	"close the connection pools"
	Pools do: [ :p | p shutDown ].! !

!WSConnectionPool class methodsFor: 'as yet unclassified' stamp: 'srh 4/19/2009 22:46'!
startUp
	"bring up the connection pools"
	Pools do: [ :p | p startUp ]! !

!WSConnectionPool methodsFor: 'private' stamp: 'srh 4/20/2009 09:51'!
allocateSessions: number 
	Transcript show: 'Allocating ', number printString, ' additional sessions'.
	1 to: number do: [ :i|
		Transcript show: '...', i printString.
		sessions nextPut: (location newSession
			connectAs: 'pool'; yourself) ].
	Transcript show: '...Done';cr! !

!WSConnectionPool methodsFor: 'private' stamp: 'srh 4/20/2009 09:03'!
assureMinimumAvailable
	" Ensures that there's at least minFree sessions available - but no more than maximum "
	| available |
	available := sessions size.
	Transcript show: 'Available sessions = ', available printString;cr.
	[ self allocateSessions: (minFree - available min: maximum - available + activeSessions size) ] 
		forkAt: Processor userBackgroundPriority.
	Transcript show: 'Leaving assumeMinimumAvailable';cr.! !

!WSConnectionPool methodsFor: 'as yet unclassified' stamp: 'srh 4/19/2009 22:21'!
initializeWithLocation: aLocation.
	self initialize.
	location := aLocation.
	minFree := 3.
	highWater := 7.
	maximum := 15.
	enabled := false.
	sessions := SharedQueue new.
	activeSessions := IdentitySet new.
	activeSema := Semaphore forMutualExclusion.! !

!WSConnectionPool methodsFor: 'as yet unclassified' stamp: 'srh 4/20/2009 21:48'!
returnSession: aSession
	" Returns a session to the pool.
	  Abort the session to make sure there's nothing uncommitted, then remove it from the active list.
	  Then we add it back into the available sessions if we're not over the high water mark "
	Transcript show: 'Returning session: ',
		sessions size printString, ' available, ', activeSessions size printString, ' In use';cr.
	
	aSession abort. 
	activeSema critical: [activeSessions remove: aSession ifAbsent: [].
	sessions size > highWater 
		ifFalse: [ sessions nextPut: aSession]
		ifTrue: [ aSession disconnect ]].
	Transcript show: 'Session returned: ',
		sessions size printString, ' available, ', activeSessions size printString, ' In use';cr.
! !

!WSConnectionPool methodsFor: 'as yet unclassified' stamp: 'srh 4/19/2009 23:46'!
shutDown
	| lastSession |
	enabled := false.
	"close all active sessions, then flush the pool".
	activeSema critical: [ activeSessions removeAllSuchThat: [ :s | s disconnect. true ]].
	lastSession := sessions flushAllSuchThat: [ :s | s disconnect. true ].
	location isLocal ifTrue: [ lastSession ifNotNil: [ lastSession closeRepository ] ]! !

!WSConnectionPool methodsFor: 'as yet unclassified' stamp: 'srh 4/20/2009 09:15'!
startUp
	Transcript show: 'Starting up';cr.
	self assureMinimumAvailable.
	enabled := true.! !

!WSConnectionPool methodsFor: 'as yet unclassified' stamp: 'srh 4/20/2009 09:14'!
takeSession
	Transcript show: 'Taking a new session: ', 
		sessions size printString, ' available, ', activeSessions size printString, ' In use';cr.
	^enabled 
		ifTrue: [ activeSema critical: [ 
				self assureMinimumAvailable. 
				activeSessions add: sessions next]]
		ifFalse: [nil]! !

Object subclass: #WSListener
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Util'!

WSListener subclass: #WSCartListener
	instanceVariableNames: 'cart'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Announcements'!

!WSCartListener class methodsFor: 'as yet unclassified' stamp: 'srh 3/21/2009 11:27'!
cart: aCart
	^self basicNew
		initializeWithCart: aCart;
		yourself.! !

!WSCartListener methodsFor: 'as yet unclassified' stamp: 'srh 3/13/2009 20:15'!
addToCart: aProduct 
	cart add: aProduct.! !

!WSCartListener methodsFor: 'as yet unclassified' stamp: 'srh 3/21/2009 11:25'!
do: anAnnouncement
	 self addToCart: anAnnouncement product! !

!WSCartListener methodsFor: 'as yet unclassified' stamp: 'srh 3/21/2009 11:26'!
handles
	^Array with: WSAddToCart ! !

!WSCartListener methodsFor: 'as yet unclassified' stamp: 'srh 3/21/2009 11:26'!
initializeWithCart: aCart
	self initialize.
	cart := aCart.! !

WSListener subclass: #WSLightboxListener
	instanceVariableNames: 'root stack'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Util'!

!WSLightboxListener class methodsFor: 'as yet unclassified' stamp: 'srh 3/21/2009 11:19'!
root: aComponent
	^self basicNew
		initializeWithRoot: aComponent;
		yourself! !

!WSLightboxListener methodsFor: 'as yet unclassified' stamp: 'srh 3/21/2009 11:19'!
do: anAnnouncement
	self lightbox: anAnnouncement component! !

!WSLightboxListener methodsFor: 'as yet unclassified' stamp: 'srh 3/21/2009 12:15'!
handles
	^Array with: WSLightbox! !

!WSLightboxListener methodsFor: 'as yet unclassified' stamp: 'srh 3/21/2009 11:18'!
initializeWithRoot: aComponent
	self initialize.
	root := aComponent.
	stack := Stack new.! !

!WSLightboxListener methodsFor: 'as yet unclassified' stamp: 'srh 4/11/2009 12:09'!
lightbox: aComponent
	| target  result |
	target := stack isEmpty ifFalse: [ stack top ].
	stack push: aComponent.
	result := (target isNil 
		ifTrue: [root lightbox: aComponent] 
		ifFalse: [target call: aComponent]).
	stack pop.
	^result! !

!WSListener methodsFor: 'as yet unclassified' stamp: 'srh 3/21/2009 11:17'!
do: anAnnouncement
	"Perform the appropriate action for an announcement"
	self subclassResponsibility! !

!WSListener methodsFor: 'as yet unclassified' stamp: 'srh 3/21/2009 11:17'!
handles
	"Return a collection of Announccement classes this listener handles"
	^self subclassResponsibility! !

Object subclass: #WSObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Core'!

WSObject subclass: #WSAddress
	instanceVariableNames: 'address1 address2 postcode locality state country'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Core'!

!WSAddress methodsFor: 'accessing' stamp: 'srh 1/1/2009 17:17'!
address1
	^address1! !

!WSAddress methodsFor: 'accessing' stamp: 'srh 1/1/2009 18:02'!
address1: anAddress
	address1 := anAddress.! !

!WSAddress methodsFor: 'accessing' stamp: 'srh 1/1/2009 18:05'!
address2
	^address2! !

!WSAddress methodsFor: 'accessing' stamp: 'srh 1/1/2009 18:05'!
address2: anAddress
	address2 := anAddress.! !

!WSAddress methodsFor: 'accessing' stamp: 'srh 1/1/2009 18:07'!
country
	^country! !

!WSAddress methodsFor: 'accessing' stamp: 'srh 1/1/2009 18:07'!
country: aCountry
	country := aCountry! !

!WSAddress methodsFor: 'accessing' stamp: 'srh 1/1/2009 18:07'!
locality
	^locality! !

!WSAddress methodsFor: 'accessing' stamp: 'srh 1/1/2009 18:08'!
locality: aLocality
	locality := aLocality! !

!WSAddress methodsFor: 'building' stamp: 'srh 1/1/2009 21:12'!
populateFrom: anAddress
	(WSAddress selectors reject: [ :s | s endsWith: ':']) do: [ :s |
		self perform: s asMutator with: (anAddress perform: s)]! !

!WSAddress methodsFor: 'accessing' stamp: 'srh 1/1/2009 18:08'!
postcode
	^postcode! !

!WSAddress methodsFor: 'accessing' stamp: 'srh 1/1/2009 18:08'!
postcode: aPostcode
	postcode := aPostcode! !

!WSAddress methodsFor: 'accessing' stamp: 'srh 1/1/2009 18:08'!
state
	^state! !

!WSAddress methodsFor: 'accessing' stamp: 'srh 1/1/2009 18:10'!
state: aState
	state := aState! !

WSAddress subclass: #WSShippingAddress
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Core'!

!WSShippingAddress methodsFor: 'accessing' stamp: 'srh 1/1/2009 14:43'!
name
	^name! !

!WSShippingAddress methodsFor: 'accessing' stamp: 'srh 1/1/2009 14:46'!
name: aName
	name := aName! !

WSObject subclass: #WSCart
	instanceVariableNames: 'items'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Core'!

!WSCart methodsFor: 'adding' stamp: 'srh 1/4/2009 11:42'!
add: aProduct
	items add: aProduct! !

!WSCart methodsFor: 'enumerating' stamp: 'srh 1/2/2009 13:23'!
anySatisfy: aBlock
	^items anySatisfy: aBlock! !

!WSCart methodsFor: 'accessing' stamp: 'srh 12/31/2008 15:04'!
count
	^items size! !

!WSCart methodsFor: 'enumerating' stamp: 'srh 1/2/2009 09:50'!
do: aBlock
	items do: aBlock! !

!WSCart methodsFor: 'initialization' stamp: 'srh 12/31/2008 14:48'!
initialize
	items := OrderedCollection new.! !

!WSCart methodsFor: 'accessing' stamp: 'srh 6/28/2009 22:21'!
isEmpty
	^ items isEmpty! !

!WSCart methodsFor: 'accessing' stamp: 'srh 12/31/2008 14:50'!
items
	^items clone! !

!WSCart methodsFor: 'removing' stamp: 'srh 1/1/2009 14:20'!
remove: aProduct
	items remove: aProduct.! !

!WSCart methodsFor: 'accessing' stamp: 'srh 8/4/2009 15:58'!
totalInDollars
	|t|
	t := items inject: 0 into: [:a :i| a + i price].
	^(t / 100) printShowingDecimalPlaces: 2.! !

WSObject subclass: #WSCountry
	instanceVariableNames: 'code name'
	classVariableNames: 'Countries'
	poolDictionaries: ''
	category: 'WebStore-Core'!

!WSCountry class methodsFor: 'as yet unclassified' stamp: 'srh 6/27/2009 10:35'!
initialize
	super initialize.
	self populateCountryList! !

!WSCountry class methodsFor: 'as yet unclassified' stamp: 'srh 6/27/2009 10:42'!
byCode: aCode 
	^ Countries at: aCode! !

!WSCountry class methodsFor: 'as yet unclassified' stamp: 'srh 6/27/2009 10:15'!
code: twoLetterCode name: humanReadableName
	^self basicNew
		initializeWithCode: twoLetterCode name: humanReadableName;
		yourself! !

!WSCountry class methodsFor: 'as yet unclassified' stamp: 'srh 6/27/2009 10:36'!
countryList
	^Countries values! !

!WSCountry class methodsFor: 'as yet unclassified' stamp: 'srh 6/27/2009 10:36'!
new
	self shouldNotImplement! !

!WSCountry class methodsFor: 'as yet unclassified' stamp: 'srh 6/27/2009 15:52'!
populateCountryList
	"Populates or repopulates the Country Code list from the OpenCountryCodes XML feed."
	Countries := Dictionary new.
	(XMLDOMParser parseDocumentFrom: ('http://opencountrycodes.appspot.com/xml/' asUrl retrieveContents contentStream)) 
		tagsNamed: #country do: [ :e | 
			Countries at: (e attributeAt: #code) put: (WSCountry code: (e attributeAt: #code) name: (e attributeAt: #name))]! !

!WSCountry methodsFor: 'as yet unclassified' stamp: 'srh 6/27/2009 10:38'!
code
	^code! !

!WSCountry methodsFor: 'as yet unclassified' stamp: 'srh 6/27/2009 10:37'!
initializeWithCode: twoLetterCode name: humanReadableName
	self initialize.
	code := twoLetterCode.
	name := humanReadableName ! !

!WSCountry methodsFor: 'as yet unclassified' stamp: 'srh 6/27/2009 10:38'!
name
	^name! !

!WSCountry methodsFor: 'as yet unclassified' stamp: 'srh 6/27/2009 11:35'!
notEmpty
	^code notNil and: [ name notNil]! !

!WSCountry methodsFor: 'as yet unclassified' stamp: 'srh 6/27/2009 10:40'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' (', code, ' -> ', name, ')'! !

WSObject subclass: #WSCustomer
	instanceVariableNames: 'email name phone'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Core'!

!WSCustomer class methodsFor: 'as yet unclassified' stamp: 'srh 2/22/2009 12:05'!
new
	^self basicNew
		initialize;
		yourself.! !

!WSCustomer methodsFor: 'accessing' stamp: 'srh 1/1/2009 16:50'!
email
	^email! !

!WSCustomer methodsFor: 'accessing' stamp: 'srh 1/1/2009 16:52'!
email: anEmailAddress
	email := anEmailAddress! !

!WSCustomer methodsFor: 'accessing' stamp: 'srh 1/1/2009 16:50'!
name
	^name! !

!WSCustomer methodsFor: 'accessing' stamp: 'srh 1/1/2009 16:53'!
name: aName
	name := aName! !

!WSCustomer methodsFor: 'accessing' stamp: 'srh 1/1/2009 16:51'!
phone
	^phone! !

!WSCustomer methodsFor: 'accessing' stamp: 'srh 1/1/2009 16:52'!
phone: aPhoneNumber
	phone := aPhoneNumber! !

WSObject subclass: #WSImage
	instanceVariableNames: 'baseName'
	classVariableNames: 'Medium Thumb Extension'
	poolDictionaries: ''
	category: 'WebStore-Core'!

!WSImage class methodsFor: 'as yet unclassified' stamp: 'srh 7/25/2009 16:30'!
initialize
	super initialize.
	Extension := '.jpg'! !

!WSImage class methodsFor: 'as yet unclassified' stamp: 'srh 12/30/2008 22:42'!
fromStream: aStream
	^self basicNew
		initialize;
		generateImagesFrom: (ImageReadWriter formFromStream: aStream);
		yourself.
	! !

!WSImage class methodsFor: 'as yet unclassified' stamp: 'srh 7/25/2009 16:30'!
mediumDimension
	^200@200.
! !

!WSImage class methodsFor: 'as yet unclassified' stamp: 'srh 7/27/2009 09:52'!
previewDimension
	^100@100.! !

!WSImage class methodsFor: 'as yet unclassified' stamp: 'srh 7/27/2009 09:52'!
thumbDimension
	^50@50.! !

!WSImage methodsFor: 'accessing' stamp: 'srh 1/4/2009 11:33'!
fullsize
	^ baseName, '-full' , Extension! !

!WSImage methodsFor: 'as yet unclassified' stamp: 'srh 7/27/2009 09:55'!
generateImages
	| image |
	image := Form fromFileNamed: (self pathFor: self fullsize).
	(image scaledToSize: WSImage thumbDimension) writeJPEGfileNamed: (self pathFor: self thumbnail).
	(image scaledToSize: WSImage previewDimension) writeJPEGfileNamed: (self pathFor: self preview).
	(image scaledToSize: WSImage mediumDimension) writeJPEGfileNamed: (self pathFor: self medium).
! !

!WSImage methodsFor: 'as yet unclassified' stamp: 'srh 7/25/2009 16:25'!
generateImagesFrom: aForm.
	aForm writeJPEGfileNamed: (self pathFor: self fullsize).
	self generateImages! !

!WSImage methodsFor: 'initialization' stamp: 'srh 1/4/2009 11:33'!
initialize
	super initialize.
	baseName := UUID new printString! !

!WSImage methodsFor: 'accessing' stamp: 'srh 1/4/2009 11:33'!
medium
	^ baseName, '-med' , Extension! !

!WSImage methodsFor: 'class migration' stamp: 'srh 7/25/2009 16:27'!
migrate
	baseName class = UUID ifTrue: [
		baseName := baseName printString.	
	].
	self generateImages.! !

!WSImage methodsFor: 'accessing' stamp: 'srh 4/14/2009 09:57'!
pathFor: aFilename
	^(FileDirectory default directoryNamed: 'files') assureExistence fullName, FileDirectory slash, aFilename! !

!WSImage methodsFor: 'accessing' stamp: 'srh 7/27/2009 09:57'!
preview
	^ baseName, '-preview' , Extension! !

!WSImage methodsFor: 'accessing' stamp: 'srh 1/4/2009 11:32'!
thumbnail
	^ baseName, '-thumb' , Extension! !

WSObject subclass: #WSMessage
	instanceVariableNames: 'subject recipient message date'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Core'!

!WSMessage class methodsFor: 'as yet unclassified' stamp: 'srh 6/13/2009 16:45'!
orderCancelled: order reason: aReason
	^self
		to: order  customer email
		subject: ('{1} Order {2} Cancelled' format: {self prefix. order reference })
		message: ('This messages is to inform you that your order {1} has been cancelled because {2}.
if you believe this is in error, please contact us at orders@creativecorsetry.com' format: {order reference. aReason}).! !

!WSMessage class methodsFor: 'as yet unclassified' stamp: 'srh 6/13/2009 16:43'!
orderShipped: order
	^self
		to: order  customer email
		subject: ('{1} Order {2} Shipped' format: {self prefix. order reference })
		message: ('This messages confirms that your order {1} has been shipped' format: {order reference}).! !

!WSMessage class methodsFor: 'as yet unclassified' stamp: 'srh 6/13/2009 16:42'!
paymentConfirmed: order
	^self
		to: order  customer email
		subject: ('{1} Order {2} Payment Confirmed' format: {self prefix. order reference })
		message: ('This messages confirms that your payment for order {1} has been confirmed.  Please expect 2-3 weeks while your corset is made.
You will be notified when your order ships' format: {order reference}).! !

!WSMessage class methodsFor: 'as yet unclassified' stamp: 'srh 6/6/2009 16:45'!
prefix
	^'Creative Corsetry: '! !

!WSMessage class methodsFor: 'as yet unclassified' stamp: 'srh 6/6/2009 16:44'!
receivedOrder: order
	^self
		to: order  customer email
		subject: ('{1} Order {2} Received, Pending Confirmation' format: {self prefix. order reference })
		message: ('This message verifies that your order was received, you will be notified once payment has been confirmed.
Your reference number is: {1}' format: {order reference}).
	! !

!WSMessage class methodsFor: 'as yet unclassified' stamp: 'srh 6/6/2009 16:45'!
to: recipient subject: aSubject message: aMessage
	^self basicNew
		initializeWithRecipient: recipient subject: aSubject message: aMessage;
		yourself! !

!WSMessage methodsFor: 'accessing' stamp: 'srh 6/13/2009 16:15'!
date
	^date! !

!WSMessage methodsFor: 'initialization' stamp: 'srh 6/13/2009 16:14'!
initializeWithRecipient: aRecipient subject: aSubject message: aMessage 
	self initialize.
	recipient := aRecipient.
	subject := aSubject.
	message := aMessage.
	date := DateAndTime now.! !

!WSMessage methodsFor: 'accessing' stamp: 'srh 6/13/2009 16:15'!
message
	^message! !

!WSMessage methodsFor: 'accessing' stamp: 'srh 6/13/2009 16:14'!
recipient
	^recipient! !

!WSMessage methodsFor: 'actions' stamp: 'srh 6/13/2009 14:49'!
send
	" Sends the message "! !

!WSMessage methodsFor: 'accessing' stamp: 'srh 6/13/2009 16:15'!
subject
	^subject! !

!WSObject methodsFor: 'class migration' stamp: 'srh 1/3/2009 09:42'!
migrate
	"Initialize new ivars added since the object was saved"
! !

WSObject subclass: #WSOption
	instanceVariableNames: 'name required'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Core'!

!WSOption class methodsFor: 'as yet unclassified' stamp: 'srh 3/8/2009 10:03'!
label
	^self subclassResponsibility! !

!WSOption methodsFor: '*webstore-components' stamp: 'srh 5/4/2009 17:34'!
asComponent
	"Subclasses should return a new WAComponent that will display the value of this option"
	^self subclassResponsibility! !

!WSOption methodsFor: '*webstore-components' stamp: 'srh 3/11/2009 13:55'!
editField
	^ self subclassResponsibility! !

!WSOption methodsFor: 'accessing' stamp: 'srh 3/9/2009 00:15'!
name
	^name! !

!WSOption methodsFor: 'accessing' stamp: 'srh 3/9/2009 11:01'!
name: aName
	name := aName.! !

!WSOption methodsFor: 'accessing' stamp: 'srh 3/9/2009 00:16'!
required
	^required! !

!WSOption methodsFor: 'accessing' stamp: 'srh 3/9/2009 11:01'!
required:  isRequired
	required := isRequired! !

WSOption subclass: #WSTextOption
	instanceVariableNames: 'text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Core'!

!WSTextOption class methodsFor: 'as yet unclassified' stamp: 'srh 3/8/2009 10:03'!
label
	^'Text'! !

!WSTextOption methodsFor: '*webstore-components' stamp: 'srh 5/4/2009 17:40'!
asComponent
	^ WSOptionComponent option: self.! !

!WSTextOption methodsFor: '*webstore-components' stamp: 'srh 3/11/2009 13:56'!
editField
	^WSField text on: #text of: self! !

!WSTextOption methodsFor: 'as yet unclassified' stamp: 'srh 3/11/2009 14:10'!
text
	^text! !

!WSTextOption methodsFor: 'as yet unclassified' stamp: 'srh 3/11/2009 14:10'!
text: someText
	text := someText! !

WSObject subclass: #WSOrder
	instanceVariableNames: 'items address customer status id history messages'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Core'!

!WSOrder methodsFor: 'accessing' stamp: 'srh 1/1/2009 16:35'!
address
	^address! !

!WSOrder methodsFor: 'accessing' stamp: 'srh 1/1/2009 16:37'!
address: aShippingAddress
	address := aShippingAddress! !

!WSOrder methodsFor: 'actions' stamp: 'srh 6/13/2009 18:51'!
cancel: reason
	status cancel: reason.
	self sendMessage: (WSMessage orderCancelled: self reason: reason)
! !

!WSOrder methodsFor: 'actions' stamp: 'srh 2/28/2009 14:45'!
confirmPayment: reference
	status confirmPayment: reference! !

!WSOrder methodsFor: 'accessing' stamp: 'srh 1/1/2009 16:35'!
customer
	^customer! !

!WSOrder methodsFor: 'accessing' stamp: 'srh 1/1/2009 16:36'!
customer: aCustomer
	customer := aCustomer! !

!WSOrder methodsFor: 'accessing' stamp: 'srh 2/28/2009 16:14'!
date
	"The order date is the date of the first #unconfirmed status"
	^(history detect: [:s | s is: #unconfirmed] 
		ifNone: [ self error: 'Order hasn''t been placed yet']
	) date.! !

!WSOrder methodsFor: 'accessing' stamp: 'srh 2/28/2009 13:33'!
history
	^history! !

!WSOrder methodsFor: 'initialization' stamp: 'srh 6/13/2009 15:46'!
initialize
	super initialize.
	history := OrderedCollection new.
	self status: (WSStatus newFor: self).! !

!WSOrder methodsFor: 'accessing' stamp: 'srh 1/1/2009 16:35'!
items
	^items! !

!WSOrder methodsFor: 'accessing' stamp: 'srh 1/1/2009 16:36'!
items: aCollectionOfProducts 
	items := aCollectionOfProducts! !

!WSOrder methodsFor: 'actions' stamp: 'srh 6/13/2009 15:51'!
logMessage: aMessage
	"Adds a message to the log"
	self messages add: aMessage! !

!WSOrder methodsFor: 'initialization' stamp: 'srh 6/13/2009 15:45'!
messages
	^messages ifNil: [ messages := OrderedCollection new].! !

!WSOrder methodsFor: 'actions' stamp: 'srh 6/13/2009 18:50'!
placeOrder: orderId
	status placeOrder.
	id := orderId.
	self sendMessage: (WSMessage receivedOrder: self).! !

!WSOrder methodsFor: 'accessing' stamp: 'srh 1/2/2009 12:13'!
reference
	^id! !

!WSOrder methodsFor: 'actions' stamp: 'srh 6/13/2009 18:48'!
sendMessage: aMessage
	aMessage send.
	self logMessage: aMessage! !

!WSOrder methodsFor: 'actions' stamp: 'srh 6/13/2009 19:21'!
ship
	status ship.
	self sendMessage: (WSMessage orderShipped: self).! !

!WSOrder methodsFor: 'accessing' stamp: 'srh 1/2/2009 08:59'!
status
	^status! !

!WSOrder methodsFor: 'accessing' stamp: 'srh 2/28/2009 13:40'!
status: aStatus 
	status := aStatus.
	history add: aStatus! !

WSObject subclass: #WSProduct
	instanceVariableNames: 'id name description price images preview enabled options'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Core'!

!WSProduct methodsFor: 'actions' stamp: 'srh 12/30/2008 21:20'!
addImage: anImage
	images add: anImage.
	images size = 1 ifTrue: [preview := anImage]! !

!WSProduct methodsFor: 'accessing' stamp: 'srh 3/1/2009 10:11'!
customFields
	^#()! !

!WSProduct methodsFor: 'accessing' stamp: 'srh 12/29/2008 07:29'!
description
	^description! !

!WSProduct methodsFor: 'accessing' stamp: 'srh 12/29/2008 07:30'!
description: aDescription
	description := aDescription.! !

!WSProduct methodsFor: 'actions' stamp: 'srh 12/31/2008 09:58'!
disable
	enabled := false! !

!WSProduct methodsFor: 'actions' stamp: 'srh 12/31/2008 09:50'!
enable
	enabled := true! !

!WSProduct methodsFor: 'accessing' stamp: 'srh 12/31/2008 09:50'!
enabled
	^enabled! !

!WSProduct methodsFor: 'actions' stamp: 'srh 3/28/2009 09:52'!
id
	^id! !

!WSProduct methodsFor: 'actions' stamp: 'srh 3/28/2009 10:01'!
id: anId
  id ifNotNil: [Error signal: 'cannot modify id once set'].
  id := anId! !

!WSProduct methodsFor: 'accessing' stamp: 'srh 3/8/2009 22:32'!
images
	^images clone! !

!WSProduct methodsFor: 'initialization' stamp: 'srh 3/7/2009 19:37'!
initialize
	images := OrderedCollection new.
	enabled := false.	
	options := OrderedCollection new.! !

!WSProduct methodsFor: 'class migration' stamp: 'srh 3/8/2009 21:47'!
migrate
	images do: [ :i | i migrate].
	options ifNil: [options := OrderedCollection new].
	options do: [ :o| o migrate].! !

!WSProduct methodsFor: 'accessing' stamp: 'srh 12/28/2008 13:53'!
name
	^name.! !

!WSProduct methodsFor: 'accessing' stamp: 'srh 12/28/2008 13:53'!
name: aName
	name := aName.! !

!WSProduct methodsFor: 'accessing' stamp: 'srh 3/8/2009 22:32'!
options
	^options clone.! !

!WSProduct methodsFor: 'accessing' stamp: 'srh 3/8/2009 22:32'!
options: anOrderedCollection
	options := anOrderedCollection clone.! !

!WSProduct methodsFor: 'accessing' stamp: 'srh 3/21/2009 14:20'!
orderCopy
	^self deepCopy.! !

!WSProduct methodsFor: 'accessing' stamp: 'srh 12/30/2008 21:19'!
preview
	^preview! !

!WSProduct methodsFor: 'accessing' stamp: 'srh 12/30/2008 21:24'!
preview: anImage
	(images includes: anImage) ifFalse: [
		self error: 'Preview image must be one of the product''s images'
	].
	preview := anImage! !

!WSProduct methodsFor: 'accessing' stamp: 'srh 12/29/2008 07:32'!
price
	^price! !

!WSProduct methodsFor: 'accessing' stamp: 'srh 12/29/2008 07:32'!
price: priceInCents
	price := priceInCents! !

!WSProduct methodsFor: 'accessing' stamp: 'srh 8/4/2009 15:43'!
priceInDollars
	^(price / 100) printShowingDecimalPlaces: 2! !

!WSProduct methodsFor: 'actions' stamp: 'srh 12/30/2008 21:22'!
removeImage: anImage
	images remove: anImage.
	preview = anImage ifTrue: [
		preview := images isEmpty ifTrue: [nil] ifFalse: [images first]]! !

!WSProduct methodsFor: 'actions' stamp: 'srh 3/7/2009 19:38'!
removeOption: anOption
	options remove: anOption! !

WSObject subclass: #WSStore
	instanceVariableNames: 'products orders orderId productId localShipping internationalShipping'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Core'!

!WSStore methodsFor: 'actions' stamp: 'srh 3/28/2009 10:07'!
addProduct: aProduct
	products add: (aProduct id: (self nextProductId); yourself).! !

!WSStore methodsFor: 'actions' stamp: 'srh 12/30/2008 14:45'!
deleteProduct: aProduct
	products remove: aProduct! !

!WSStore methodsFor: 'initialization' stamp: 'srh 8/15/2009 09:53'!
initialize
	super initialize.
	products := OrderedCollection new.
	orders := OrderedCollection new.
	orderId := 0.
	productId := 0.
	localShipping := 0.
	internationalShipping := 0.! !

!WSStore methodsFor: 'accessing' stamp: 'srh 8/15/2009 09:54'!
internationalShipping
	^ internationalShipping! !

!WSStore methodsFor: 'accessing' stamp: 'srh 8/15/2009 09:54'!
internationalShipping: anObject
	internationalShipping := anObject! !

!WSStore methodsFor: 'accessing' stamp: 'srh 8/15/2009 09:54'!
localShipping
	^ localShipping! !

!WSStore methodsFor: 'accessing' stamp: 'srh 8/15/2009 09:54'!
localShipping: anObject
	localShipping := anObject! !

!WSStore methodsFor: 'class migration' stamp: 'srh 8/15/2009 10:10'!
migrate
	"Initialize new ivars added since the object was saved"
	orderId ifNil: [orderId := 0].
	orders ifNil: [ orders := OrderedCollection new ].
	products do: [:p |
		p id ifNil: [ p id: self nextProductId].
		p migrate].
	orders do: [:o | o migrate].
	localShipping ifNil: [ localShipping := 0].
	internationalShipping ifNil: [ internationalShipping := 0].	! !

!WSStore methodsFor: 'accessing' stamp: 'srh 1/3/2009 09:40'!
nextOrderId
	orderId := orderId + 1.
	^orderId printString.! !

!WSStore methodsFor: 'accessing' stamp: 'srh 3/28/2009 10:04'!
nextProductId
	productId := productId + 1.
	^productId printString.! !

!WSStore methodsFor: 'accessing' stamp: 'srh 2/28/2009 14:55'!
orders
	^orders! !

!WSStore methodsFor: 'actions' stamp: 'srh 1/3/2009 09:39'!
placeOrder: anOrder
	anOrder placeOrder: self nextOrderId.
	orders add: anOrder.! !

!WSStore methodsFor: 'accessing' stamp: 'srh 4/11/2009 12:31'!
productWithId: anId
	^products detect: [ :p | p id = anId ]! !

!WSStore methodsFor: 'accessing' stamp: 'srh 2/28/2009 14:56'!
products
	^products.! !

Object subclass: #WSRule
	instanceVariableNames: 'rule message'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Util'!

!WSRule class methodsFor: 'as yet unclassified' stamp: 'srh 3/8/2009 17:41'!
rule: aBlock message: aMessage
	^self basicNew
		initializeWithRule:  aBlock message: aMessage;
		yourself.! !

!WSRule methodsFor: 'as yet unclassified' stamp: 'srh 3/8/2009 17:42'!
initializeWithRule: aRule message: aMessage
	message := aMessage.
	rule := aRule.
	self initialize! !

!WSRule methodsFor: 'as yet unclassified' stamp: 'srh 12/30/2008 19:02'!
message
	^message! !

!WSRule methodsFor: 'as yet unclassified' stamp: 'srh 12/30/2008 19:02'!
rule
	^rule! !

!WSRule methodsFor: 'as yet unclassified' stamp: 'srh 12/30/2008 19:04'!
testRule: value
	^rule value: value! !

Object subclass: #WSStatus
	instanceVariableNames: 'date owner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Core'!

!WSStatus commentStamp: 'srh 2/28/2009 11:22' prior: 0!
A WSStatus represents the current status of an order

Instance Variables
	date:		<Object>
	owner:		<WSOrder> (or, technically anything implementing #state:)
date
	- The date and time the current status was entered
	
owner
	- The class 'owning' this state. #state: is called on this class to change its state.
!

WSStatus subclass: #WSCancelledStatus
	instanceVariableNames: 'reason'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Core'!

!WSCancelledStatus class methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 14:00'!
owner: anObject
	self shouldNotImplement.! !

!WSCancelledStatus class methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 14:00'!
owner: anObject reason: aString
	^self basicNew
		initializeWithOwner: anObject reason: aString;
		yourself! !

!WSCancelledStatus methodsFor: 'initialization' stamp: 'srh 2/28/2009 13:59'!
initializeWithOwner: anOwner reason: aString
	self initializeWithOwner: anOwner.
	reason := aString.! !

!WSCancelledStatus methodsFor: 'accessing' stamp: 'srh 2/28/2009 11:03'!
name
	^#cancelled! !

!WSCancelledStatus methodsFor: 'accessing' stamp: 'srh 2/28/2009 13:59'!
reason
	^reason! !

WSStatus subclass: #WSConfirmedStatus
	instanceVariableNames: 'reference'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Core'!

!WSConfirmedStatus class methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 12:33'!
owner: anObject
	^self shouldNotImplement! !

!WSConfirmedStatus class methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 12:33'!
owner: anObject reference: aString
	^self basicNew
		initializeWithOwner: anObject reference: aString;
		yourself.! !

!WSConfirmedStatus methodsFor: 'actions' stamp: 'srh 2/28/2009 14:01'!
cancel: reason
	^ owner status: (WSCancelledStatus owner: owner reason: reason)! !

!WSConfirmedStatus methodsFor: 'initialization' stamp: 'srh 2/28/2009 12:34'!
initializeWithOwner: anOwner reference: aString
	self initializeWithOwner: anOwner.
	reference := aString.! !

!WSConfirmedStatus methodsFor: 'accessing' stamp: 'srh 2/28/2009 11:03'!
name
	^#confirmed! !

!WSConfirmedStatus methodsFor: 'accessing' stamp: 'srh 2/28/2009 12:34'!
reference
	^reference! !

!WSConfirmedStatus methodsFor: 'actions' stamp: 'srh 2/28/2009 13:40'!
ship
	^ owner status: (WSShippedStatus owner: owner)! !

WSStatus subclass: #WSNewStatus
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Core'!

!WSNewStatus methodsFor: 'accessing' stamp: 'srh 2/28/2009 11:01'!
name
	^#new! !

!WSNewStatus methodsFor: 'actions' stamp: 'srh 2/28/2009 13:40'!
placeOrder
	^ owner status: (WSUnconfirmedStatus owner: owner)! !

WSStatus subclass: #WSShippedStatus
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Core'!

!WSShippedStatus methodsFor: 'accessing' stamp: 'srh 2/28/2009 11:03'!
name
	^#shipped! !

!WSStatus class methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 11:47'!
new
	self shouldNotImplement.! !

!WSStatus class methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 11:48'!
newFor: anOwner
	^WSNewStatus owner: anOwner! !

!WSStatus class methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 11:21'!
owner: anObject
	^self basicNew
		initializeWithOwner: anObject;
		yourself.! !

!WSStatus methodsFor: 'actions' stamp: 'srh 2/28/2009 14:39'!
cancel: reason
	^self invalidStateChange: #cancel! !

!WSStatus methodsFor: 'actions' stamp: 'srh 2/28/2009 12:39'!
confirmPayment: aReference
	^self invalidStateChange: #confirmPayment! !

!WSStatus methodsFor: 'accessing' stamp: 'srh 2/28/2009 11:06'!
date
	^date! !

!WSStatus methodsFor: 'initialization' stamp: 'srh 4/27/2009 12:35'!
details
	^''! !

!WSStatus methodsFor: 'initialization' stamp: 'srh 3/9/2009 11:12'!
initializeWithOwner: anObject
	self initialize.
	owner := anObject.
	date := DateAndTime now.
! !

!WSStatus methodsFor: 'error handling' stamp: 'srh 2/28/2009 11:28'!
invalidStateChange: aSymbol
	self error: 'The message ', aSymbol printString, ' does not make sense for the state ', self name printString! !

!WSStatus methodsFor: 'testing' stamp: 'srh 2/28/2009 11:05'!
is: aSymbol
	^self name = aSymbol! !

!WSStatus methodsFor: 'accessing' stamp: 'srh 2/28/2009 10:59'!
name
	^self subclassResponsibility.! !

!WSStatus methodsFor: 'actions' stamp: 'srh 2/28/2009 11:29'!
placeOrder
	^self invalidStateChange: #placeOrder! !

!WSStatus methodsFor: 'actions' stamp: 'srh 2/28/2009 11:30'!
ship
	^self invalidStateChange: #ship! !

WSStatus subclass: #WSUnconfirmedStatus
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Core'!

!WSUnconfirmedStatus methodsFor: 'actions' stamp: 'srh 2/28/2009 14:07'!
cancel: reason
	^ owner status: (WSCancelledStatus owner: owner reason: reason)! !

!WSUnconfirmedStatus methodsFor: 'actions' stamp: 'srh 2/28/2009 13:40'!
confirmPayment: aReference 
	^ owner status: (WSConfirmedStatus 
			owner: owner
			reference: aReference)! !

!WSUnconfirmedStatus methodsFor: 'accessing' stamp: 'srh 2/28/2009 11:03'!
name
	^#unconfirmed! !

WATask subclass: #WSCheckoutProcess
	instanceVariableNames: 'wizard'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Checkout'!

!WSCheckoutProcess methodsFor: 'as yet unclassified' stamp: 'srh 4/11/2009 20:02'!
go
	[| order | 
	order := self call: wizard.
	order ifNil: [self answer].
	
	[(WSPlaceOrderCommand store: self store order: order) run ] 
		on: WSOrderError do: [:e | 
			self call: (WSOrderErrorPage error: e).
			wizard goToFirstPage].
	self call: (WSPayPalCheckout order: order).
	self answer] repeat! !

!WSCheckoutProcess methodsFor: 'as yet unclassified' stamp: 'srh 1/1/2009 22:00'!
initialize
	super initialize.
	wizard := WSCheckoutWizard new.! !

!WSCheckoutProcess methodsFor: 'as yet unclassified' stamp: 'srh 1/2/2009 17:50'!
store
	^self session store! !

!WSCheckoutProcess methodsFor: 'as yet unclassified' stamp: 'srh 1/4/2009 21:00'!
wizard
	"for testing purposes"
	^wizard! !

!WSCheckoutProcess methodsFor: 'as yet unclassified' stamp: 'srh 1/4/2009 21:00'!
wizard: aWizard
	"for testing purposes"
	wizard := aWizard! !

WASystemConfiguration subclass: #WSConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Components'!

!WSConfiguration methodsFor: 'as yet unclassified' stamp: 'srh 7/13/2009 17:48'!
attributes
	^Array 
		with: (WAStringAttribute key: #paypalHost group: #paypal)
		with: (WAStringAttribute key: #paypalIPNHost group: #paypal)
		with: (WAStringAttribute key: #accountEmail group: #paypal)
		with: (WAStringAttribute key: #poolId group: #connectionPool)! !

!WSConfiguration methodsFor: 'as yet unclassified' stamp: 'srh 7/13/2009 17:49'!
paypalHost
	^ 'www.sandbox.paypal.com'! !

!WSConfiguration methodsFor: 'as yet unclassified' stamp: 'srh 7/13/2009 17:49'!
paypalIPNHost
	^ 'ppdummy.stuartherring.net'! !

!WSConfiguration methodsFor: 'as yet unclassified' stamp: 'srh 4/19/2009 23:17'!
poolId
	^'storePool'! !

WAImageTag subclass: #WSImageBrush
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Components'!

!WSImageBrush methodsFor: 'as yet unclassified' stamp: 'srh 4/14/2009 11:58'!
image: anImage
	self url: WSImageLibrary / anImage.! !

WASession subclass: #WSSession
	instanceVariableNames: 'store announcer magmaSession pool'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Components'!

!WSSession methodsFor: 'as yet unclassified' stamp: 'srh 3/23/2009 17:46'!
actionUrlForKey: aString 
    | url |
    url := super actionUrlForKey: aString.
    (self currentRequest cookieAt: self application handlerCookieName) 
            ifNotNil: [ url parameters removeKey: self application handlerField ].
    ^ url! !

!WSSession methodsFor: 'as yet unclassified' stamp: 'srh 3/10/2009 20:30'!
announce: anAnnouncement
	announcer announce: anAnnouncement! !

!WSSession methodsFor: 'as yet unclassified' stamp: 'srh 3/10/2009 20:52'!
announcer
	^announcer! !

!WSSession methodsFor: 'as yet unclassified' stamp: 'srh 4/20/2009 21:40'!
expire
	self returnMagmaSession! !

!WSSession methodsFor: 'as yet unclassified' stamp: 'srh 4/20/2009 21:37'!
initialize
	super initialize.
	announcer := Announcer new.! !

!WSSession methodsFor: 'as yet unclassified' stamp: 'srh 4/20/2009 21:38'!
keepTransaction
	^true! !

!WSSession methodsFor: 'as yet unclassified' stamp: 'srh 4/20/2009 21:06'!
magmaSession
	^magmaSession ifNil: [Transcript show: 'Creating new magmaSession';cr..
		magmaSession := self pool takeSession ]! !

!WSSession methodsFor: 'as yet unclassified' stamp: 'srh 3/10/2009 20:52'!
on: anAnnouncement do: aBlock
	^announcer on: anAnnouncement do: aBlock.! !

!WSSession methodsFor: 'as yet unclassified' stamp: 'srh 4/20/2009 21:00'!
pool
	^pool ifNil: [ pool := (WSConnectionPool at: (self application preferenceAt: #poolId))].! !

!WSSession methodsFor: 'as yet unclassified' stamp: 'srh 4/20/2009 21:40'!
refreshMagmaSession
	magmaSession ifNotNil: [ magmaSession refresh ].! !

!WSSession methodsFor: 'as yet unclassified' stamp: 'srh 4/20/2009 21:41'!
responseForRequest: aRequest
" If return the transaction after each request, unless we've decided we need to keep it. "
	self refreshMagmaSession.
	^[WSCurrentTransactionProvider use: [self magmaSession] during: [super responseForRequest: aRequest]]
		ensure: [ self keepTransaction ifFalse: [ self returnMagmaSession ]]! !

!WSSession methodsFor: 'as yet unclassified' stamp: 'srh 4/20/2009 21:48'!
returnMagmaSession
	magmaSession ifNotNil: [ self pool returnSession: magmaSession. magmaSession := nil ]! !

!WSSession methodsFor: 'as yet unclassified' stamp: 'srh 4/20/2009 20:47'!
returnResponse: aResponse 
    (self currentRequest cookieAt: self application handlerCookieName) 
        ifNil: [ aResponse addCookie: self sessionCookie ].
    ^ super returnResponse: aResponse
! !

!WSSession methodsFor: 'as yet unclassified' stamp: 'srh 4/1/2009 23:36'!
store
	store ifNil: [
		store := self magmaSession root at: #store ifAbsent: [ self magmaSession commit: [ self magmaSession root at: #store put: WSStore new]]].
	^store! !

!WSSession methodsFor: 'as yet unclassified' stamp: 'srh 4/11/2009 12:43'!
urlForProduct: aProduct
	^self baseUrl
		addParameter: #product value: aProduct id;
		yourself.! !

Error subclass: #WSOrderError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Core'!
WSKom initialize!
WSConnectionPool initialize!
WSCountry initialize!
WSImage initialize!
